.model flat, C
.486P

.data
;_DATA SEGMENT DWORD PUBLIC USE32 'DATA'
align 4

regpack struct
	PC  dd ?
	Y   dd ?
	X   dd ?
	DBR_2less db ?
		db ?
	DBR db ?
		db ?
	D   dd ?
	A   dd ?
	P   db 4 dup (?)
	S   dd ?
	E   db 4 dup (?)
regpack ends

FCARRY     equ  1
FZERO      equ  2
FINTERRUPT equ  4
FDECIMAL   equ  8
FINDEX     equ  16
FMEMORY    equ  32
FOVERFLOW  equ  64
FNEGATIVE  equ  128

extrn _registers:dword near
extrn _scan_cycles:dword near
extrn _startaddr:dword near
extrn _debug_instr:dword near
extrn _rom:dword near          ; pointer
extrn _state:byte near         ; first two elements: end_wai, within_wai
extrn _returntogui:byte near

_reg regpack <>
PUBLIC _reg

NZ_8bit db  02h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h   ; /* 00-0F */
        db  00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h   ; /* 10-1F */
        db  00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h   ; /* 20-2F */
        db  00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h   ; /* 30-3F */
        db  00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h   ; /* 40-4F */
        db  00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h   ; /* 50-5F */
        db  00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h   ; /* 60-6F */
        db  00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h,00h   ; /* 70-7F */
        db  80h,80h,80h,80h,80h,80h,80h,80h,80h,80h,80h,80h,80h,80h,80h,80h   ; /* 80-8F */
        db  80h,80h,80h,80h,80h,80h,80h,80h,80h,80h,80h,80h,80h,80h,80h,80h   ; /* 90-9F */
        db  80h,80h,80h,80h,80h,80h,80h,80h,80h,80h,80h,80h,80h,80h,80h,80h   ; /* A0-AF */
        db  80h,80h,80h,80h,80h,80h,80h,80h,80h,80h,80h,80h,80h,80h,80h,80h   ; /* B0-BF */
        db  80h,80h,80h,80h,80h,80h,80h,80h,80h,80h,80h,80h,80h,80h,80h,80h   ; /* C0-CF */
        db  80h,80h,80h,80h,80h,80h,80h,80h,80h,80h,80h,80h,80h,80h,80h,80h   ; /* D0-DF */
        db  80h,80h,80h,80h,80h,80h,80h,80h,80h,80h,80h,80h,80h,80h,80h,80h   ; /* E0-EF */
        db  80h,80h,80h,80h,80h,80h,80h,80h,80h,80h,80h,80h,80h,80h,80h,80h   ; /* F0-FF */

;****************************************************************************
;                        SNES MEMORY ACCESS MACROS
;****************************************************************************

	; EAX USED AS TEMPORARY; don't hold an arg in EAX.

convert_snesptr macro snesaddr
	; Takes snes address and converts it to a PC pointer.  reg is 32-bit.
	; EAX destroyed.
	mov eax, snesaddr
	shr eax, 11
	and snesaddr, 01FFFh     ; offset
	and al, 0FCh
	mov eax, [_startaddr+eax] ; base pointer
	add snesaddr, eax        ; add 'em
endm convert_snesptr

trapandwrite8 macro pcptr, reg
	; Takes data from reg and puts it in "snesaddr" and traps the write
	local notrom, notrap, isrom
	cmp pcptr, [_rom]
	jb notrom
	cmp pcptr, [_rom] + 300000h
	jb isrom
notrom:
	mov [pcptr], reg
	cmp pcptr, offset _registers
	jb notrap
	cmp pcptr, offset _registers + 4000h
	jae notrap
	mov byte  [_reg.P], cl
	mov dword [_reg.PC], edx
	mov dword [_scan_cycles], esi
	push eax
	push edx
	push ecx
	push dword 0
	push pcptr
	call _trapregwrite
	pop eax
	pop edx
	pop ecx
	pop edx
	pop eax
notrap:
isrom:
endm writesnesmem

trapandwrite16 macro pcptr, lo, hi
	; Takes data from reg and puts it in "snesaddr" and traps the write
	local notrom, notrap, isrom
	cmp pcptr, [_rom]
	jb notrom
	cmp pcptr, [_rom] + 300000h
	jb isrom
notrom:
	mov byte [pcptr], lo
	mov byte [pcptr+1], hi
	cmp pcptr, offset [_registers]
	jb notrap
	cmp pcptr, offset [_registers] + 4000h
	jae notrap
	mov byte  [_reg.P], cl
	mov dword [_reg.PC], edx
	mov dword [_scan_cycles], esi
	push eax
	push edx
	push ecx
	push dword 1
	push pcptr
	call _trapregwrite
	pop eax  ; arg 1
	pop edx  ; arg 2
	pop ecx
	pop edx
	pop eax
notrap:
isrom:
endm writesnesmem

trapandread8 macro pcptr
	; Traps the read of a PC pointer pointing to a part of SNES address space
	local notrap
	cmp pcptr, offset _registers
	jb notrap
	cmp pcptr, offset _registers + 4000h
	jae notrap
	mov byte  [_reg.P], cl
	mov dword [_reg.PC], edx
	mov dword [_scan_cycles], esi
	push eax
	push edx
	push ecx
	push dword 0
	push pcptr
	call _trapregread
	pop eax  ; arg 1
	pop edx  ; arg 2
	pop ecx
	pop edx
	pop eax
	mov esi, dword [_scan_cycles]
notrap:
	mov pcptr, [pcptr]
endm trapandread

trapandread16 macro pcptr
	; Traps the read of a PC pointer pointing to a part of SNES address space
	local notrap
	cmp pcptr, offset _registers
	jb notrap
	cmp pcptr, offset _registers + 4000h
	jae notrap
	mov byte  [_reg.P], cl
	mov dword [_reg.PC], edx
	mov dword [_scan_cycles], esi
	push eax
	push edx
	push ecx
	push dword 1
	push pcptr
	call _trapregread
	pop eax  ; arg 1
	pop edx  ; arg 2
	pop ecx
	pop edx
	pop eax
	mov esi, dword [_scan_cycles]
notrap:
	mov pcptr, [pcptr]
endm trapandread

;****************************************************************************
;                          ADDRESSING MODE MACROS
;****************************************************************************

	; ADDRESSING MODE MACROS: These load EBX with the pointer to value; EAX 
	; used as temporary.  Indirections are not read trapped.  Assumes EBX
	; contains OPDATA.

convert_abs_code macro
	shr ebx, 8
	mov eax, edx
	and ebx, 0000FFFFh
	and eax, 00FF0000h
	or  ebx, eax
endm load_absdataaddress

convert_abs_data macro        ; Converts OPDATA (EBX) to SNES 24bit address
	; value returned in EBX   ; For absolute addressing modes
	shr ebx, 8
	and ebx, 0FFFFh
	or  ebx, dword [_reg.DBR_2less]
endm load_absdataaddress

convert_dir macro             ; Converts OPDATA (EBX) to SNES 24bit address
	; value returned in EBX   ; For direct addressing modes
	shr ebx, 8
	and ebx, 0FFh
	add ebx, dword [_reg.D]
	; and ebx, 0FFFFh generally useless, but adds extra cycle!
endm load_absdataaddress

get_imm macro
	shr ebx, 8
endm get_imm

load_abs macro      ; (SNESMEM ((DBR << 16) + OPWORD))
	convert_abs_data
	convert_snesptr ebx
endm load_abs

load_abs_long macro ; (SNESMEM (OPLONG))
	shr ebx, 8      ; now have 24bit address
	convert_snesptr ebx
endm load_abs_long

load_dir macro      ; (SNESMEM ((D + OPBYTE) & 0xFFFF))
	convert_dir
	convert_snesptr ebx
endm load_dir

load_dir_indir_index_y8 macro ; ( _tmp = *(word*)SNESMEM(D + OPBYTE) + (DBR << 16) + INDEX_Y, SNESMEM(_tmp) )
	convert_dir
	convert_snesptr ebx
	mov ebx, [ebx]
	and ebx, 0FFFFh
	movzx eax, byte [_reg.Y]
	or  ebx, dword [_reg.DBR_2less]
	add ebx, eax              ; Indexes DO NOT wrap around on word boundaries, thank heaven
	convert_snesptr ebx
endm load_dir_indir_index_y

load_dir_indir_index_y16 macro ; ( _tmp = *(word*)SNESMEM(D + OPBYTE) + (DBR << 16) + INDEX_Y, SNESMEM(_tmp) )
	convert_dir
	convert_snesptr ebx
	mov ebx, [ebx]
	and ebx, 0FFFFh
	or  ebx, dword [_reg.DBR_2less]
	add ebx, dword [_reg.Y]
	convert_snesptr ebx
endm load_dir_indir_index_y

load_dir_indir_long macro ; ( _tmp = (*(dword*)SNESMEM( (D + OPBYTE)&0xFFFF )) & 0xFFFFFF, SNESMEM (_tmp) )
	convert_dir
	convert_snesptr ebx
	mov ebx, [ebx]
	and ebx, 00FFFFFFh
	convert_snesptr ebx
endm load_dir_indir_long

load_dir_indir_long_index_y8 macro ; ( _tmp = ((*(dword*)SNESMEM( (D+OPBYTE)&0xFFFF )) & 0xFFFFFF) + INDEX_Y, SNESMEM (_tmp) )
	convert_dir
	convert_snesptr ebx
	mov ebx, [ebx]
	and ebx, 00FFFFFFh
	movzx eax, byte [_reg.Y]
	add ebx, eax
	convert_snesptr ebx
endm load_dir_indir_long_index_y8

load_dir_indir_long_index_y16 macro ; ( _tmp = ((*(dword*)SNESMEM( (D+OPBYTE)&0xFFFF )) & 0xFFFFFF) + INDEX_Y, SNESMEM (_tmp) )
	convert_dir
	convert_snesptr ebx
	mov ebx, [ebx]
	and ebx, 00FFFFFFh
	add ebx, dword [_reg.Y]
	convert_snesptr ebx
endm load_dir_indir_long_index_y16

load_dir_index_indir_x8 macro ; ( _tmp = *(word *)SNESMEM( (((D+OPBYTE)&0xFFFF) + INDEX_X) & 0xFFFF ) + (DBR << 16), SNESMEM (_tmp) )
	convert_dir
	movzx eax, byte [_reg.X]
	add ebx, eax
	convert_snesptr ebx
	mov ebx, [ebx]
	and ebx, 0FFFFh
	or  ebx, dword [_reg.DBR_2less]
	convert_snesptr ebx
endm load_dir_index_indir_x8

load_dir_index_indir_x16 macro ; ( _tmp = *(word *)SNESMEM( (((D+OPBYTE)&0xFFFF) + INDEX_X) & 0xFFFF ) + (DBR << 16), SNESMEM (_tmp) )
	convert_dir
	add ebx, dword [_reg.X]
	convert_snesptr ebx
	mov ebx, [ebx]
	and ebx, 0FFFFh
	or  ebx, dword [_reg.DBR_2less]
	convert_snesptr ebx
endm load_dir_index_indir_x16

load_dir_index_x8 macro ; ( SNESMEM(D + OPBYTE + INDEX_X) )
	convert_dir
	xor eax, eax
	mov al, byte [_reg.X]
	add ebx, eax
	convert_snesptr ebx
endm load_dir_index_x8

load_dir_index_x16 macro ; ( SNESMEM(D + OPBYTE + INDEX_X) )
	convert_dir
	add ebx, dword [_reg.X]
	convert_snesptr ebx
endm load_dir_index_x16

load_dir_index_y8 macro ; ( SNESMEM(D + OPBYTE + INDEX_Y) )
	convert_dir
	xor eax, eax
	mov al, byte [_reg.Y]
	add ebx, eax
	convert_snesptr ebx
endm load_dir_index_y8

load_dir_index_y16 macro ; ( SNESMEM(D + OPBYTE + INDEX_Y) )
	convert_dir
	add ebx, dword [_reg.Y]
	convert_snesptr ebx
endm load_dir_index_y16

load_abs_index_x8 macro ; ( _tmp = (DBR << 16) + OPWORD + INDEX_X, SNESMEM(_tmp) )
	convert_abs_data
	xor eax, eax
	mov al, byte [_reg.X]
	add ebx, eax
	convert_snesptr ebx
endm load_abs_index_x8

load_abs_index_x16 macro ; ( _tmp = (DBR << 16) + OPWORD + INDEX_X, SNESMEM(_tmp) )
	convert_abs_data
	add ebx, dword [_reg.X]
	convert_snesptr ebx
endm load_abs_index_x16

load_abs_index_y8 macro ; ( _tmp = (DBR << 16) + OPWORD + INDEX_Y, SNESMEM(_tmp) )
	convert_abs_data
	xor eax, eax
	mov al, byte [_reg.Y]
	add ebx, eax
	convert_snesptr ebx
endm load_abs_index_y8

load_abs_index_y16 macro ; ( _tmp = (DBR << 16) + OPWORD + INDEX_Y, SNESMEM(_tmp) )
	convert_abs_data
	add ebx, dword [_reg.Y]
	convert_snesptr ebx
endm load_abs_index_y16

load_abs_long_index_x8 macro ; ( SNESMEM(OPLONG + INDEX_X) )
	shr ebx, 8
	xor eax, eax
	mov al, byte [_reg.X]
	add ebx, eax
	convert_snesptr ebx
endm load_abs_long_index_x8

load_abs_long_index_x16 macro ; ( SNESMEM(OPLONG + INDEX_X) )
	shr ebx, 8
	add ebx, dword [_reg.X]
	convert_snesptr ebx
endm load_abs_long_index_x16

load_abs_indir macro ; ( SNESMEM (OPWORD) ) Apparently you set PC=*ABS_INDIR
	shr ebx, 8
	and ebx, 0FFFFh
	convert_snesptr ebx
endm load_abs_indir

load_dir_indir macro ; ( _tmp = *(word*)SNESMEM((D + OPBYTE) & 0xFFFF) + (DBR << 16), SNESMEM (_tmp) )
	convert_dir
	convert_snesptr ebx
	mov ebx, [ebx]
	and ebx, 0FFFFh
	or  ebx, dword [_reg.DBR_2less]
	convert_snesptr ebx
endm load_dir_indir

load_abs_index_indir_x8_code macro ; ( _tmp = OPWORD + INDEX_X + (PC & 0xFF0000), *(word*)SNESMEM(_tmp) | (PC & 0xFF0000) )
	shr ebx, 8
	and ebx, 0FFFFh
	mov eax, edx
	and eax, 00FF0000h
	mov al, byte [_reg.X]
	add ebx, eax
	convert_snesptr ebx ; EAX destroyed
	mov ebx, [ebx]
	mov eax, edx
	and ebx, 0FFFFh
	and eax, 00FF0000h ; PBR
	or  ebx, eax
	; SET PC to this final value
endm load_abs_index_indir_x8

load_abs_index_indir_x16_code macro ; ( _tmp = OPWORD + INDEX_X + (PC & 0xFF0000), *(word*)SNESMEM(_tmp) | (PC & 0xFF0000) )
	shr ebx, 8
	and ebx, 0FFFFh
	mov eax, edx
	and eax, 00FF0000h
	or  eax, dword [_reg.X]
	add ebx, eax
	convert_snesptr ebx ; EAX destroyed
	mov ebx, [ebx]
	and ebx, 0FFFFh
	mov eax, edx
	and eax, 00FF0000h
	or  ebx, eax
	; SET PC to this final value
endm load_abs_index_indir_x16

load_s_rel macro ; (SNESMEM (S + OPBYTE))
	shr ebx, 8
	and ebx, 0FFh
	add ebx, dword [_reg.S]
	convert_snesptr ebx
endm load_s_rel

load_s_rel_indir_index_y8 macro ; ( _tmp = *(word*)SNESMEM (S + OPBYTE) + (DBR << 16) + INDEX_Y, SNESMEM (_tmp) )
	shr ebx, 8
	and ebx, 0FFh
	add ebx, dword [_reg.S]
	convert_snesptr ebx
	mov ebx, [ebx]
	and ebx, 0FFFFh
	or  ebx, dword [_reg.DBR_2less]
	xor eax, eax
	mov al, byte [_reg.Y]
	add ebx, eax
	convert_snesptr ebx
endm load_s_rel_indir_index_y8

load_s_rel_indir_index_y16 macro ; ( _tmp = *(word*)SNESMEM (S + OPBYTE) + (DBR << 16) + INDEX_Y, SNESMEM (_tmp) )
	shr ebx, 8
	and ebx, 0FFh
	add ebx, dword [_reg.S]
	convert_snesptr ebx
	mov ebx, [ebx]
	and ebx, 0FFFFh
	or  ebx, dword [_reg.DBR_2less]
	add ebx, dword [_reg.Y]
	convert_snesptr ebx
endm load_s_rel_indir_index_y16

;****************************************************************************
;                          STACK PUSH/PULL MACROS
;****************************************************************************

	; There don't seem to be any instances where edi and pushbyte are used in the same place...
pushbyte macro bytereg  ; DESTROYS EDI and EAX!!! But not EBP, good since longcall uses EBP _and_ pushbyte
	mov edi, dword [_reg.S]
	convert_snesptr edi
	mov byte [edi], bytereg
	;dec word [_reg.S]
	mov edi, dword [_reg.S]
	dec edi
	and edi, 0000FFFFh
	mov dword [_reg.S], edi
endm pushbyte

pullbyte macro bytereg  ; DESTROYS EDI and EAX and EBP!!!
	inc_word [_reg.S]
	mov edi, dword [_reg.S]
	convert_snesptr edi
	mov bytereg, byte [edi]
endm pushbyte

;****************************************************************************
;                               MISC. MACROS
;****************************************************************************

docount macro addtopc, subfromcycles
	add edx, addtopc
	sub esi, subfromcycles
endm docount

dobreak macro
	ret
endm dobreak

dobreak_mxchange macro
	pop eax ; Pop return address
	jmp looptop_check
endm dobreak_mxchange

mainloop macro vectortable
@@:
	mov ebx, edx        ; Memory at PC
	mov eax, ebx
	shr eax, 11
	and ebx, 01FFFh     ; offset
	and al, 0FCh
	mov eax, [_startaddr+eax] ; base pointer
	add ebx, eax        ; add 'em
	inc dword [_debug_instr]
	mov ebx, [ebx]
	movzx eax, bl
	call [vectortable+eax*4]
	test esi, esi
	jns @B
	jmp exitroutine
endm mainloop

; Workarounds for error in word handling in the assembler -- MODIFIES EBP!

dec_word macro what
	mov ebp, dword what
	dec ebp
	and ebp, 0000FFFFh
	mov dword what, ebp
endm dec_word

inc_word macro what
	mov ebp, dword what
	inc ebp
	and ebp, 0000FFFFh
	mov dword what, ebp
endm inc_word

;****************************************************************************
;                             INSTRUCTION MACROS
;****************************************************************************

vectorcall macro e_vector, not_e_vector
	; Pushes PC and P, then changes PC to vector
	mov ebx, edx
	shr ebx, 8
	pushbyte bh
	pushbyte bl
	pushbyte dl
	pushbyte cl
	mov edx, not_e_vector
	or byte [_reg.E], 0
	jz @F ; not emulation mode
	mov edx, e_vector
@@: convert_snesptr edx
	mov edx, [edx]
	and edx, 0FFFFh
endm vectorcall

shortcall macro lowbyte, highbyte  ; Add 1 less than normal to PC before using macro
	pushbyte dh
	pushbyte dl
	mov dl, lowbyte
	mov dh, highbyte
endm vectorcall

longcall_ebx macro   ; Add 1 less to PC before using macro
	mov ebp, ebx
	mov ebx, edx
	and ebp, 00FFFFFFh
	shr ebx, 8
	pushbyte bh
	pushbyte bl
	pushbyte dl
	mov edx, ebp
endm vectorcall

; EBX: Pointer to data of 65816 operand
; EDX: PC   ESI: cycles left  CL: Flags
; EAX: Temporary, not used by trapandread

nzflag_xfer macro
	setz ch
	sets ah
	shl ch, 1
	shl ah, 7
	or  cl, ch
	or  cl, ah
endm

nzcflag_xfer_sub macro ; complements carry first
	; set complement of carry (cmp and sub differ on x86 machines)
	setnc al
	setz ch
	sets ah
	shl ch, 1
	shl ah, 7
	or  cl, ch
	or  cl, al
	or  cl, ah
endm

adc8 macro imm
	local dobcd, notoverflow, notoverflowbcd, alldone
	ifb <imm>
		trapandread8 ebx
	endif
	mov ch, cl      ; ch==cl==P
	movzx eax, byte [_reg.A]
	and cl, 0FFh-FOVERFLOW-FZERO-FCARRY-FNEGATIVE ; clear affected flags
	test cl, FDECIMAL
	jnz dobcd
	shr ch, 1        ; get 65816 carry flag
	adc al, bl       ; add and save accumulator
	mov byte [_reg.A], al
	setc ch          ; get carry flag state 1=carry.
	                 ; would use adc cl,0 but that changes the overflow flag
	jno notoverflow
	or  cl, FOVERFLOW
notoverflow:
	or  cl, ch       ; save carry flag state
	or  cl, [nz_8bit + eax] ; get zero/negative flags
	jmp alldone
dobcd:
	shr	ch,1         ; Move 6502 Carry to 80x86's
	adc al, bl
	daa              ; change al according to BCD adjust rules
	mov byte [_reg.A], al
	setc ch          ; get carry flag state 1=carry.
	                 ; would use adc cl,0 but that changes the overflow flag
	jno notoverflow
	or  cl, FOVERFLOW
notoverflowbcd:
	or  cl, ch       ; save carry flag state
	or  cl, [nz_8bit + eax] ; get zero/negative flags
alldone:
endm adc8
adc16 macro imm
	local dobcd, notoverflow, notoverflowbcd, alldone
	ifb <imm>
		trapandread16 ebx
	endif
	mov ch, cl      ; ch==cl==P
	mov eax, dword [_reg.A]
	and cl, 0FFh-FOVERFLOW-FZERO-FCARRY-FNEGATIVE ; clear affected flags
	test cl, FDECIMAL
	jnz dobcd
	shr ch, 1        ; get 65816 carry flag
	adc ax, bx       ; add and save accumulator
	mov dword [_reg.A], eax
	setz al
	setc ch          ; get carry flag state 1=carry.
	                 ; would use adc cl,0 but that changes the overflow flag
	sets ah
	jno notoverflow
	or  cl, FOVERFLOW
notoverflow:
	shl ah, 7
	or  cl, ch       ; save carry flag state
	shl al, 1
	or  cl, ah
	or  cl, al
	jmp alldone
dobcd:
	shr ch, 1        ; get 65816 carry flag
	adc al, bl       ; eax=65816 A; Do one byte at a time with BCD
	daa              ; adjust for BCD
	mov byte [_reg.A], al
	adc ah, bh
	mov al, ah
	daa
	mov byte [_reg.A + 1], al
	setc ch          ; get carry flag state 1=carry.
	setz al
	sets ah
	jno notoverflow
	or  cl, FOVERFLOW
notoverflowbcd:
	or  dword [_reg.A], 0  ; set nz flags
	or  cl, ch       ; save carry flag state
	shl ah, 7
	shl al, 1
	or  cl, ah
	or  cl, al
alldone:
endm adc16

and8 macro imm ; and memory with A
	ifb <imm>
		trapandread8 ebx
	endif
	movzx eax, byte [_reg.A]
	and cl, 0FFh-FZERO-FNEGATIVE ; clear affected flags
	and al, bl
	mov byte [_reg.A], al
	or  cl, [nz_8bit + eax]
endm and8
and16 macro imm
	ifb <imm>
		trapandread16 ebx
	endif
	mov eax, dword [_reg.A]
	and cl, 0FFh-FZERO-FNEGATIVE ; clear affected flags
	and ax, bx
	mov dword [_reg.A], eax
	nzflag_xfer
endm and16

shl8 macro
	mov edi, ebx        ; save pointer to data
	trapandread8 ebx
	and cl, 0FFh-FZERO-FNEGATIVE-FCARRY; clear affected flags
	test bl, 80h
	setnz ch
	movzx ebx, bl
	or cl, ch  ; left bit into carry
	shl bl, 1
	or cl, [nz_8bit + ebx]
	trapandwrite8 edi, bl
endm shl8
shl16 macro
	mov edi, ebx        ; save pointer to data
	trapandread16 ebx
	and ebx, 0000FFFFh
	and cl, 0FFh-FZERO-FNEGATIVE-FCARRY; clear affected flags
	test bh, 80h
	setnz ch
	or cl, ch  ; left bit into carry
	shl bx, 1
	nzflag_xfer
	trapandwrite16 edi, bl, bh
endm shl16

shl8_a macro
	movzx ebx, byte [_reg.A]
	and cl, 0FFh-FZERO-FNEGATIVE-FCARRY; clear affected flags
	shl bl, 1
	jnc @F
	or cl, FCARRY  ; left bit into carry
@@: mov byte [_reg.A], bl
	or cl, [nz_8bit + ebx]
endm shl8
shl16_a macro
	mov ebx, dword [_reg.A]
	and cl, 0FFh-FZERO-FNEGATIVE-FCARRY; clear affected flags
	shl bx, 1
	setz al
	sets ch
	jnc @F
	or cl, FCARRY  ; left bit into carry
@@: shl ch, 7
	shl al, 1
	or cl, ch
	mov dword [_reg.A], ebx
	or cl, al
endm shl16

bit8 macro imm
	local notzero
	ifb <imm>
		trapandread8 ebx   ; read memory at [ebx] into ebx
	endif
	mov eax, ebx       ; save memory
	ifb <imm>
		and cl, 0FFh-FZERO-FNEGATIVE-FOVERFLOW ; clear affected flags
	else
		and cl, 0FFh-FZERO ; clear affected flags
	endif
	and bl, byte [_reg.A]
	jnz notzero
	or  cl, FZERO      ; zero flag
notzero:
	ifb <imm>
		and al, 80h+40h    ; get flags
		or  cl, al         ; transfer
	endif
endm bit8
bit16 macro imm
	local notzero
	ifb <imm>
		trapandread16 ebx  ; read memory at [ebx] into ebx
	endif
	mov eax, ebx           ; save memory
	ifb <imm>
		and cl, 0FFh-FZERO-FNEGATIVE-FOVERFLOW ; clear affected flags
	else
		and cl, 0FFh-FZERO ; clear affected flags
	endif
	and bx, word [_reg.A]
	jnz notzero
	or  cl, FZERO      ; zero flag
notzero:
	ifb <imm>
		and ah, 80h+40h    ; get flags
		or  cl, ah         ; transfer
	endif
endm bit16

cmp8 macro imm
	ifb <imm>
		trapandread8 ebx ; read memory byte
	endif
	and cl, 0FFh-FNEGATIVE-FZERO-FCARRY  ; clear flags affected
	cmp byte [_reg.A], bl         ; compare operand with A
	nzcflag_xfer_sub
endm cmp8
cmp16 macro imm
	ifb <imm>
		trapandread16 ebx ; read memory word
	endif
	and cl, 0FFh-FNEGATIVE-FZERO-FCARRY  ; clear flags affected
	cmp word [_reg.A], bx         ; compare operand with A
	nzcflag_xfer_sub
endm cmp16

cpx8 macro imm
	ifb <imm>
		trapandread8 ebx ; read memory byte
	endif
	and cl, 0FFh-FNEGATIVE-FZERO-FCARRY  ; clear flags affected
	cmp byte [_reg.X], bl         ; compare operand with A
	nzcflag_xfer_sub
endm cpx8
cpx16 macro imm
	ifb <imm>
		trapandread16 ebx ; read memory word
	endif
	and cl, 0FFh-FNEGATIVE-FZERO-FCARRY  ; clear flags affected
	cmp word [_reg.X], bx         ; compare operand with A
	nzcflag_xfer_sub
endm cpx16

cpy8 macro imm
	ifb <imm>
		trapandread8 ebx ; read memory byte
	endif
	and cl, 0FFh-FNEGATIVE-FZERO-FCARRY  ; clear flags affected
	cmp byte [_reg.Y], bl         ; compare operand with A
	; set complement of carry (cmp uses a sub, which differs on x86 machines)
	nzcflag_xfer_sub
endm cpy8
cpy16 macro imm
	ifb <imm>
		trapandread16 ebx ; read memory word
	endif
	and cl, 0FFh-FNEGATIVE-FZERO-FCARRY  ; clear flags affected
	cmp word [_reg.Y], bx         ; compare operand with A
	nzcflag_xfer_sub
endm cpy16

dec8 macro
	mov edi, ebx     ; remember address
	trapandread8 ebx ; read memory byte
	and cl, 0FFh-FNEGATIVE-FZERO  ; clear flags affected
	movzx ebx, bl
	dec bl
	or cl, [nz_8bit + ebx]
	trapandwrite8 edi, bl
endm dec8
dec16 macro
	mov edi, ebx     ; remember address
	trapandread16 ebx ; read memory byte
	and cl, 0FFh-FNEGATIVE-FZERO  ; clear flags affected
	dec bx
	nzflag_xfer
	trapandwrite16 edi, bl, bh
endm dec16

dex8 macro
	and cl, 0FFh-FNEGATIVE-FZERO  ; clear flags affected
	dec byte [_reg.X]
	nzflag_xfer
endm dex8
dex16 macro
	mov ebx, dword [_reg.X]
	and cl, 0FFh-FNEGATIVE-FZERO  ; clear flags affected
	;dec word [_reg.X]
	dec bx
	mov byte [_reg.X], bl
	mov byte [_reg.X+1], bh
	nzflag_xfer
endm dex16

dey8 macro
	and cl, 0FFh-FNEGATIVE-FZERO  ; clear flags affected
	dec byte [_reg.Y]
	nzflag_xfer
endm dey8
dey16 macro
	mov ebx, dword [_reg.Y]
	and cl, 0FFh-FNEGATIVE-FZERO  ; clear flags affected
	;dec word [_reg.Y]
	dec bx
	mov byte [_reg.Y], bl
	mov byte [_reg.Y+1], bh
	nzflag_xfer
endm dey16

deca8 macro
	and cl, 0FFh-FNEGATIVE-FZERO  ; clear flags affected
	dec byte [_reg.A]
	nzflag_xfer
endm dex8
deca16 macro
	mov ebx, dword [_reg.A]
	and cl, 0FFh-FNEGATIVE-FZERO  ; clear flags affected
	;dec word [_reg.A]
	dec bx
	mov byte [_reg.A], bl
	mov byte [_reg.A+1], bh
	nzflag_xfer
endm deca16

xor8 macro imm ; XOR with A
	ifb <imm>
		trapandread8 ebx
	endif
	and cl, 0FFh-FNEGATIVE-FZERO  ; clear flags affected
	xor byte [_reg.A], bl
	nzflag_xfer
endm xor8
xor16 macro imm ; XOR with A
	ifb <imm>
		trapandread16 ebx
	endif
	and cl, 0FFh-FNEGATIVE-FZERO  ; clear flags affected
	xor word [_reg.A], bx
	nzflag_xfer
endm xor16

inc8 macro
	mov edi, ebx     ; remember address
	trapandread8 ebx ; read memory byte
	movzx ebx, bl
	and cl, 0FFh-FNEGATIVE-FZERO  ; clear flags affected
	inc bl
	or cl, [nz_8bit + ebx]
	trapandwrite8 edi, bl
endm inc8
inc16 macro
	mov edi, ebx     ; remember address
	trapandread16 ebx ; read memory byte
	and cl, 0FFh-FNEGATIVE-FZERO  ; clear flags affected
	inc bx
	nzflag_xfer
	trapandwrite16 edi, bl, bh
endm inc16

inx8 macro
	and cl, 0FFh-FNEGATIVE-FZERO  ; clear flags affected
	inc byte [_reg.X]
	nzflag_xfer
endm inx8
inx16 macro
	mov ebx, dword [_reg.X]
	and cl, 0FFh-FNEGATIVE-FZERO  ; clear flags affected
	;inc word [_reg.X]
	inc bx
	mov byte [_reg.X], bl
	nzflag_xfer
	mov byte [_reg.X+1], bh
endm inx16

iny8 macro
	and cl, 0FFh-FNEGATIVE-FZERO  ; clear flags affected
	inc byte [_reg.Y]
	nzflag_xfer
endm iny8
iny16 macro
	mov ebx, dword [_reg.Y]
	and cl, 0FFh-FNEGATIVE-FZERO  ; clear flags affected
	;inc word [_reg.Y]
	inc bx
	mov byte [_reg.Y], bl
	nzflag_xfer
	mov byte [_reg.Y+1], bh
endm iny16

inca8 macro
	and cl, 0FFh-FNEGATIVE-FZERO  ; clear flags affected
	inc byte [_reg.A]
	nzflag_xfer
endm inca8
inca16 macro
	mov ebx, dword [_reg.A]
	and cl, 0FFh-FNEGATIVE-FZERO  ; clear flags affected
	;inc word [_reg.A]
	inc bx
	mov byte [_reg.A], bl
	nzflag_xfer
	mov byte [_reg.A+1], bh
endm inca16

lda8 macro imm
	ifb <imm>
		trapandread8 ebx ; read memory byte
	endif
	and cl, 0FFh-FNEGATIVE-FZERO  ; clear flags affected
	movzx ebx, bl
	mov byte [_reg.A], bl
	or  cl, [nz_8bit + ebx]
endm lda8
lda16 macro imm
	local notnegative, notzero
	ifb <imm>
		trapandread16 ebx ; read memory byte
	endif
	mov byte [_reg.A], bl
	and ebx, 0000FFFFh
	and cl, 0FFh-FNEGATIVE-FZERO  ; clear flags affected
	mov byte [_reg.A + 1], bh
	test bh, 80h
	jz  notnegative
	or  cl, FNEGATIVE
notnegative:
	test ebx, ebx
	jnz notzero
	or  cl, FZERO
notzero:
endm lda16

ldx8 macro imm
	ifb <imm>
		trapandread8 ebx
	endif
	and cl, 0FFh-FNEGATIVE-FZERO  ; clear flags affected
	movzx ebx, bl
	mov byte [_reg.X], bl
	or  cl, [nz_8bit + ebx]
endm ldx8
ldx16 macro imm
	local notnegative, notzero
	ifb <imm>
		trapandread16 ebx
	endif
	mov byte [_reg.X], bl
	and ebx, 0000FFFFh
	and cl, 0FFh-FNEGATIVE-FZERO  ; clear flags affected
	mov byte [_reg.X + 1], bh
	test bh, 80h
	jz  notnegative
	or  cl, FNEGATIVE
notnegative:
	test ebx, ebx
	jnz notzero
	or  cl, FZERO
notzero:
endm ldx16

ldy8 macro imm
	ifb <imm>
		trapandread8 ebx
	endif
	and cl, 0FFh-FNEGATIVE-FZERO  ; clear flags affected
	movzx ebx, bl
	mov byte [_reg.Y], bl
	or  cl, [nz_8bit + ebx]
endm ldy8
ldy16 macro imm
	local notnegative, notzero
	ifb <imm>
		trapandread16 ebx
	endif
	mov byte [_reg.Y], bl
	and ebx, 0000FFFFh
	and cl, 0FFh-FNEGATIVE-FZERO  ; clear flags affected
	mov byte [_reg.Y + 1], bh
	test bh, 80h
	jz  notnegative
	or  cl, FNEGATIVE
notnegative:
	test ebx, ebx
	jnz notzero
	or  cl, FZERO
notzero:
endm ldy16

shr8 macro
	mov edi, ebx        ; save pointer to data
	trapandread8 ebx
	and cl, 0FFh-FZERO-FNEGATIVE-FCARRY; clear affected flags
	shr bl, 1
	setz al
	setc ch
	shl al, 1  ; get zero flag
	or cl, ch  ; right bit into carry
	or cl, al
	trapandwrite8 edi, bl
endm shr8
shr16 macro
	mov edi, ebx        ; save pointer to data
	trapandread16 ebx
	and ebx, 0000FFFFh
	and cl, 0FFh-FZERO-FNEGATIVE-FCARRY; clear affected flags
	shr bx, 1
	setc ch
	test ebx, ebx
	setz al
	or  cl, ch  ; right bit into carry
	shl al, 1  ; get zero flag
	or  cl, al
	; negative flag always cleared
	trapandwrite16 edi, bl, bh
endm shr16

shr8_a macro
	mov bl, byte [_reg.A]
	and cl, 0FFh-FZERO-FNEGATIVE-FCARRY; clear affected flags, N always = 0
	shr bl, 1
	setc ch
	jnz @F
	or cl, FZERO
@@: mov byte [_reg.A], bl
	or cl, ch  ; right bit into carry
	; never negative flag
endm shr8_a
shr16_a macro
	mov ebx, dword [_reg.A]
	and cl, 0FFh-FZERO-FNEGATIVE-FCARRY; clear affected flags
	shr ebx, 1
	setc ch
	jnz @F
	or  cl, FZERO
@@: mov dword [_reg.A], ebx
	or  cl, ch  ; right bit into carry
endm shr16_a

ora8 macro imm
	ifb <imm>
		trapandread8 ebx
	endif
	movzx eax, byte [_reg.A]
	and cl, 0FFh-FZERO-FNEGATIVE ; clear affected flags
	or  al, bl
	mov byte [_reg.A], al
	or  cl, [nz_8bit + eax]
endm ora8
ora16 macro imm
	ifb <imm>
		trapandread16 ebx
	endif
	mov eax, dword [_reg.A]
	and cl, 0FFh-FZERO-FNEGATIVE ; clear affected flags
	or  ax, bx
	mov dword [_reg.A], eax
	nzflag_xfer
endm ora16

rol8 macro
	mov edi, ebx        ; save pointer to data
	trapandread8 ebx
	mov ch, cl
	and cl, 0FFh-FZERO-FNEGATIVE-FCARRY; clear affected flags
	movzx ebx, bl       ; pad with zeros for indexing
	shr ch, 1           ; 65816 carry->x86 carry
	rcl bl, 1           ; rotate left memory
	jnc @F
	or cl, FCARRY       ; get new carry flag
@@:	or cl, [nz_8bit + ebx]
	trapandwrite8 edi, bl
endm rol8
rol16 macro
	mov edi, ebx        ; save pointer to data
	trapandread16 ebx
	mov ch, cl
	and cl, 0FFh-FZERO-FNEGATIVE-FCARRY; clear affected flags
	shr ch, 1           ; 65816 carry->x86 carry
	rcl bx, 1           ; rotate left memory
	jnc @F
	or cl, FCARRY
@@: test bh, 80h
	jz @F
	or cl, FNEGATIVE
@@: test ebx, 0000FFFFh
	jnz @F
	or cl, FZERO
@@:	trapandwrite16 edi, bl, bh
endm rol16

rol8_a macro
	mov ch, cl
	and cl, 0FFh-FZERO-FNEGATIVE-FCARRY; clear affected flags
	movzx ebx, byte [_reg.A]
	shr ch, 1           ; 65816 carry->x86 carry
	rcl bl, 1           ; rotate left memory
	jnc @F
	or cl, FCARRY
@@: mov byte [_reg.A], bl
	or cl, [nz_8bit + ebx]
endm rol8_a
rol16_a macro
	mov ch, cl
	and cl, 0FFh-FZERO-FNEGATIVE-FCARRY; clear affected flags
	mov ebx, dword [_reg.A]
	shr ch, 1           ; 65816 carry->x86 carry
	rcl bx, 1           ; rotate left memory  [NB: x86 rotate doesn't affect SF/ZF]
	jnc @F
	or cl, FCARRY
@@: test bh, 80h
	jz @F
	or cl, FNEGATIVE
@@: test ebx, ebx
	jnz @F
	or cl, FZERO
@@:	mov dword [_reg.A], ebx
endm rol16_a

ror8 macro
	local notcarry
	mov edi, ebx        ; save pointer to data
	trapandread8 ebx
	mov ch, cl
	and cl, 0FFh-FZERO-FNEGATIVE-FCARRY; clear affected flags
	movzx ebx, bl       ; pad with zeros for indexing
	shr ch, 1           ; 65816 carry->x86 carry
	rcr bl, 1           ; rotate right memory [NB: x86 rotate doesn't affect SF/ZF]
	jnc notcarry
	or cl, FCARRY       ; get new carry flag
notcarry:
	or cl, [nz_8bit + ebx]
	trapandwrite8 edi, bl
endm ror8
ror16 macro
	mov edi, ebx        ; save pointer to data
	trapandread16 ebx
	mov ch, cl
	and cl, 0FFh-FZERO-FNEGATIVE-FCARRY; clear affected flags
	shr ch, 1           ; 65816 carry->x86 carry
	rcr bx, 1           ; rotate right memory  [NB: x86 rotate doesn't affect SF/ZF]
	jnc @F
	or cl, FCARRY
@@: test bh, 80h
	jz @F
	or cl, FNEGATIVE
@@: test ebx, 0000FFFFh
	jnz @F
	or cl, FZERO
@@:	trapandwrite16 edi, bl, bh
endm ror16

ror8_a macro
	local notcarry
	movzx ebx, byte [_reg.A] ; pad with zeros for indexing
	mov ch, cl
	and cl, 0FFh-FZERO-FNEGATIVE-FCARRY; clear affected flags
	shr ch, 1           ; 65816 carry->x86 carry
	rcr bl, 1           ; rotate right accum
	jnc notcarry
	or cl, FCARRY       ; get new carry flag
notcarry:
	mov byte [_reg.A], bl
	or cl, [nz_8bit + ebx]
endm ror8_a
ror16_a macro
	mov ebx, dword [_reg.A]
	mov ch, cl
	and cl, 0FFh-FZERO-FNEGATIVE-FCARRY; clear affected flags
	shr ch, 1           ; 65816 carry->x86 carry
	rcr bx, 1           ; rotate right accum
	jnc @F
	or cl, FCARRY
@@: test bh, 80h
	jz @F
	or cl, FNEGATIVE
@@: test ebx, ebx
	jnz @F
	or cl, FZERO
@@:	mov dword [_reg.A], ebx
endm ror16_a

sbc8 macro imm
	local dobcd, notoverflow, notoverflowbcd, alldone
	ifb <imm>
		trapandread8 ebx
	endif
	mov ch, cl      ; ch==cl==P
	movzx eax, byte [_reg.A]
	and cl, 0FFh-FOVERFLOW-FZERO-FCARRY-FNEGATIVE ; clear affected flags
	test cl, FDECIMAL
	jnz dobcd
	shr ch, 1        ; get 65816 carry flag
	cmc              ; complement carry to do it right on an x86 machine...
	sbb al, bl       ; subtract and save accumulator
	mov byte [_reg.A], al
	setnc ch         ; get carry flag state 0=carry, 1=not carry.
	                 ; would use adc cl,0 but that changes the overflow flag
	jno notoverflow
	or  cl, FOVERFLOW
notoverflow:
	or  cl, ch       ; save carry flag state
	or  cl, [nz_8bit + eax] ; get zero/negative flags
	jmp alldone
dobcd:
	shr	ch,1         ; Move 65816 Carry to 80x86's
	cmc              ; complement carry to do it right on an x86 machine...
	sbb al, bl
	das              ; change al according to BCD adjust rules
	mov byte [_reg.A], al
	setnc ch         ; get carry flag state 1=not carry.
	jno notoverflow
	or  cl, FOVERFLOW
notoverflowbcd:
	or  cl, ch       ; save carry flag state
	or  cl, [nz_8bit + eax] ; get zero/negative flags
alldone:
endm sbc8
sbc16 macro imm
	local dobcd, notoverflow, notoverflowbcd, alldone
	ifb <imm>
		trapandread16 ebx
	endif
	mov ch, cl      ; ch==cl==P
	mov eax, dword [_reg.A]
	and cl, 0FFh-FOVERFLOW-FZERO-FCARRY-FNEGATIVE ; clear affected flags
	test cl, FDECIMAL
	jnz dobcd
	shr ch, 1        ; get 65816 carry flag
	cmc              ; complement carry to do it right on an x86 machine...
	sbb ax, bx       ; subtract and save accumulator
	mov dword [_reg.A], eax
	setnc ch         ; get carry flag state 0=carry, 1=not carry.
	setz al
	sets ah
	jno notoverflow
	or  cl, FOVERFLOW
notoverflow:
	shl ah, 7
	or  cl, ch       ; save carry flag state
	shl al, 1
	or  cl, ah
	or  cl, al
	jmp alldone
dobcd:
	shr ch, 1        ; get 65816 carry flag
	cmc              ; complement carry to do it right on an x86 machine...
	sbb al, bl       ; subtract, one byte at a time...
	das
	mov byte [_reg.A], al
	sbb ah, bh
	mov al, ah
	das
	setnc ch          ; get carry flag state 1=not carry.
	sets ah
	mov byte [_reg.A + 1], al
	setz al
	jno notoverflow
	or  cl, FOVERFLOW
notoverflowbcd:
	shl ah, 7
	or  cl, ch        ; save carry flag state
	shl al, 1
	or  cl, ah        ; negative flag
	or  cl, al        ; zero flag
alldone:
endm sbc16

sta8 macro
	mov al, byte [_reg.A]
	trapandwrite8 ebx, al
endm sta8
sta16 macro
	mov eax, dword [_reg.A]
	trapandwrite16 ebx, al, ah
endm sta16

stx8 macro
	mov al, byte [_reg.X]
	trapandwrite8 ebx, al
endm stx8
stx16 macro
	mov eax, dword [_reg.X]
	trapandwrite16 ebx, al, ah
endm stx16

sty8 macro
	mov al, byte [_reg.Y]
	trapandwrite8 ebx, al
endm sty8
sty16 macro
	mov eax, dword [_reg.Y]
	trapandwrite16 ebx, al, ah
endm sty16

clr8 macro
	xor ch, ch
	trapandwrite8 ebx, ch
endm clr8
clr16 macro
	xor ch, ch
	trapandwrite16 ebx, ch, ch
endm clr16

trb8 macro
	mov edi, ebx
	trapandread8 ebx
	mov al, byte [_reg.A]
	and cl, 0FFh-FZERO
	test bl, al
	jnz @F
	or cl, FZERO
@@: not al
	and bl, al
	trapandwrite8 edi, bl
endm trb8
trb16 macro
	mov edi, ebx
	trapandread16 ebx
	and ebx, 0000FFFFh
	mov eax, dword [_reg.A]
	and cl, 0FFh-FZERO
	test ebx, eax
	jnz @F
	or cl, FZERO
@@: not eax
	and ebx, eax
	trapandwrite16 edi, bl, bh
endm trb16

tsb8 macro
	mov edi, ebx
	trapandread8 ebx
	and cl, 0FFh-FZERO
	test bl, byte [_reg.A]
	jnz @F
	or cl, FZERO
@@:	or  bl, byte [_reg.A]
	trapandwrite8 edi, bl
endm tsb8
tsb16 macro
	mov edi, ebx
	trapandread16 ebx
	and cl, 0FFh-FZERO
	test ebx, dword [_reg.A]
	jnz @F
	or  cl, FZERO
@@: or  ebx, dword [_reg.A]
	trapandwrite16 edi, bl, bh
endm tsb16

transfer_16to16 macro from, to
	mov ebx, dword [_reg.from]
	and cl, 0FFh-FNEGATIVE-FZERO
	mov dword [_reg.to], ebx ; transfer 16-bit
	test ebx, ebx ; get zero
	jnz @F
	or  cl, FZERO
@@: test ebx, 00008000h
	jz  @F
	or cl, FNEGATIVE
@@:
endm transfer_16to16

transfer_8to16 macro from, to
	mov ebx, dword [_reg.from]
	and cl, 0FFh-FNEGATIVE-FZERO
	mov dword [_reg.to], ebx ; transfer 16-bit
	test ebx, ebx ; get zero
	jnz @F
	or  cl, FZERO
@@: test ebx, 00008000h
	jz  @F
	or cl, FNEGATIVE
@@:	; For behaviour compatibility with zSNES, transfer all 16 bits
;	movzx ebx, byte [_reg.from]
;	and cl, 0FFh-FNEGATIVE-FZERO
;	mov dword [_reg.to], ebx ; transfer 16-bit
;	test ebx, ebx ; get zero
;	jnz @F
;	or cl, FZERO
;@@: ; negative flag never set
endm transfer_8to16

transfer_8to8 macro from, to
	mov bl, byte [_reg.from]
	and ecx, 000000FFh-FNEGATIVE-FZERO ; clear ch too
	mov byte [_reg.to], bl ; transfer 8-bit
	test bl, bl ; get zero/negative
	jnz @F
	mov ch, FZERO
@@:	jns  @F
	or cl, FNEGATIVE
@@:	or cl, ch
endm transfer_8to8

;****************************************************************************
;                         OPCODE EMULATION JUMP TABLE
;****************************************************************************

opcodetable_m0x0 dd offset op00m0x0, op01m0x0, op02m0x0, op03m0x0, op04m0x0, op05m0x0, op06m0x0, op07m0x0, op08m0x0, op09m0x0, op0Am0x0, op0Bm0x0, op0Cm0x0, op0Dm0x0, op0Em0x0, op0Fm0x0
dd op10m0x0, op11m0x0, op12m0x0, op13m0x0, op14m0x0, op15m0x0, op16m0x0, op17m0x0, op18m0x0, op19m0x0, op1Am0x0, op1Bm0x0, op1Cm0x0, op1Dm0x0, op1Em0x0, op1Fm0x0
dd op20m0x0, op21m0x0, op22m0x0, op23m0x0, op24m0x0, op25m0x0, op26m0x0, op27m0x0, op28m0x0, op29m0x0, op2Am0x0, op2Bm0x0, op2Cm0x0, op2Dm0x0, op2Em0x0, op2Fm0x0
dd op30m0x0, op31m0x0, op32m0x0, op33m0x0, op34m0x0, op35m0x0, op36m0x0, op37m0x0, op38m0x0, op39m0x0, op3Am0x0, op3Bm0x0, op3Cm0x0, op3Dm0x0, op3Em0x0, op3Fm0x0
dd op40m0x0, op41m0x0, op42m0x0, op43m0x0, op44m0x0, op45m0x0, op46m0x0, op47m0x0, op48m0x0, op49m0x0, op4Am0x0, op4Bm0x0, op4Cm0x0, op4Dm0x0, op4Em0x0, op4Fm0x0
dd op50m0x0, op51m0x0, op52m0x0, op53m0x0, op54m0x0, op55m0x0, op56m0x0, op57m0x0, op58m0x0, op59m0x0, op5Am0x0, op5Bm0x0, op5Cm0x0, op5Dm0x0, op5Em0x0, op5Fm0x0
dd op60m0x0, op61m0x0, op62m0x0, op63m0x0, op64m0x0, op65m0x0, op66m0x0, op67m0x0, op68m0x0, op69m0x0, op6Am0x0, op6Bm0x0, op6Cm0x0, op6Dm0x0, op6Em0x0, op6Fm0x0
dd op70m0x0, op71m0x0, op72m0x0, op73m0x0, op74m0x0, op75m0x0, op76m0x0, op77m0x0, op78m0x0, op79m0x0, op7Am0x0, op7Bm0x0, op7Cm0x0, op7Dm0x0, op7Em0x0, op7Fm0x0
dd op80m0x0, op81m0x0, op82m0x0, op83m0x0, op84m0x0, op85m0x0, op86m0x0, op87m0x0, op88m0x0, op89m0x0, op8Am0x0, op8Bm0x0, op8Cm0x0, op8Dm0x0, op8Em0x0, op8Fm0x0
dd op90m0x0, op91m0x0, op92m0x0, op93m0x0, op94m0x0, op95m0x0, op96m0x0, op97m0x0, op98m0x0, op99m0x0, op9Am0x0, op9Bm0x0, op9Cm0x0, op9Dm0x0, op9Em0x0, op9Fm0x0
dd opA0m0x0, opA1m0x0, opA2m0x0, opA3m0x0, opA4m0x0, opA5m0x0, opA6m0x0, opA7m0x0, opA8m0x0, opA9m0x0, opAAm0x0, opABm0x0, opACm0x0, opADm0x0, opAEm0x0, opAFm0x0
dd opB0m0x0, opB1m0x0, opB2m0x0, opB3m0x0, opB4m0x0, opB5m0x0, opB6m0x0, opB7m0x0, opB8m0x0, opB9m0x0, opBAm0x0, opBBm0x0, opBCm0x0, opBDm0x0, opBEm0x0, opBFm0x0
dd opC0m0x0, opC1m0x0, opC2m0x0, opC3m0x0, opC4m0x0, opC5m0x0, opC6m0x0, opC7m0x0, opC8m0x0, opC9m0x0, opCAm0x0, opCBm0x0, opCCm0x0, opCDm0x0, opCEm0x0, opCFm0x0
dd opD0m0x0, opD1m0x0, opD2m0x0, opD3m0x0, opD4m0x0, opD5m0x0, opD6m0x0, opD7m0x0, opD8m0x0, opD9m0x0, opDAm0x0, opDBm0x0, opDCm0x0, opDDm0x0, opDEm0x0, opDFm0x0
dd opE0m0x0, opE1m0x0, opE2m0x0, opE3m0x0, opE4m0x0, opE5m0x0, opE6m0x0, opE7m0x0, opE8m0x0, opE9m0x0, opEAm0x0, opEBm0x0, opECm0x0, opEDm0x0, opEEm0x0, opEFm0x0
dd opF0m0x0, opF1m0x0, opF2m0x0, opF3m0x0, opF4m0x0, opF5m0x0, opF6m0x0, opF7m0x0, opF8m0x0, opF9m0x0, opFAm0x0, opFBm0x0, opFCm0x0, opFDm0x0, opFEm0x0, opFFm0x0

opcodetable_m0x1 dd op00m0x1, op01m0x1, op02m0x1, op03m0x1, op04m0x1, op05m0x1, op06m0x1, op07m0x1, op08m0x1, op09m0x1, op0Am0x1, op0Bm0x1, op0Cm0x1, op0Dm0x1, op0Em0x1, op0Fm0x1
dd op10m0x1, op11m0x1, op12m0x1, op13m0x1, op14m0x1, op15m0x1, op16m0x1, op17m0x1, op18m0x1, op19m0x1, op1Am0x1, op1Bm0x1, op1Cm0x1, op1Dm0x1, op1Em0x1, op1Fm0x1
dd op20m0x1, op21m0x1, op22m0x1, op23m0x1, op24m0x1, op25m0x1, op26m0x1, op27m0x1, op28m0x1, op29m0x1, op2Am0x1, op2Bm0x1, op2Cm0x1, op2Dm0x1, op2Em0x1, op2Fm0x1
dd op30m0x1, op31m0x1, op32m0x1, op33m0x1, op34m0x1, op35m0x1, op36m0x1, op37m0x1, op38m0x1, op39m0x1, op3Am0x1, op3Bm0x1, op3Cm0x1, op3Dm0x1, op3Em0x1, op3Fm0x1
dd op40m0x1, op41m0x1, op42m0x1, op43m0x1, op44m0x1, op45m0x1, op46m0x1, op47m0x1, op48m0x1, op49m0x1, op4Am0x1, op4Bm0x1, op4Cm0x1, op4Dm0x1, op4Em0x1, op4Fm0x1
dd op50m0x1, op51m0x1, op52m0x1, op53m0x1, op54m0x1, op55m0x1, op56m0x1, op57m0x1, op58m0x1, op59m0x1, op5Am0x1, op5Bm0x1, op5Cm0x1, op5Dm0x1, op5Em0x1, op5Fm0x1
dd op60m0x1, op61m0x1, op62m0x1, op63m0x1, op64m0x1, op65m0x1, op66m0x1, op67m0x1, op68m0x1, op69m0x1, op6Am0x1, op6Bm0x1, op6Cm0x1, op6Dm0x1, op6Em0x1, op6Fm0x1
dd op70m0x1, op71m0x1, op72m0x1, op73m0x1, op74m0x1, op75m0x1, op76m0x1, op77m0x1, op78m0x1, op79m0x1, op7Am0x1, op7Bm0x1, op7Cm0x1, op7Dm0x1, op7Em0x1, op7Fm0x1
dd op80m0x1, op81m0x1, op82m0x1, op83m0x1, op84m0x1, op85m0x1, op86m0x1, op87m0x1, op88m0x1, op89m0x1, op8Am0x1, op8Bm0x1, op8Cm0x1, op8Dm0x1, op8Em0x1, op8Fm0x1
dd op90m0x1, op91m0x1, op92m0x1, op93m0x1, op94m0x1, op95m0x1, op96m0x1, op97m0x1, op98m0x1, op99m0x1, op9Am0x1, op9Bm0x1, op9Cm0x1, op9Dm0x1, op9Em0x1, op9Fm0x1
dd opA0m0x1, opA1m0x1, opA2m0x1, opA3m0x1, opA4m0x1, opA5m0x1, opA6m0x1, opA7m0x1, opA8m0x1, opA9m0x1, opAAm0x1, opABm0x1, opACm0x1, opADm0x1, opAEm0x1, opAFm0x1
dd opB0m0x1, opB1m0x1, opB2m0x1, opB3m0x1, opB4m0x1, opB5m0x1, opB6m0x1, opB7m0x1, opB8m0x1, opB9m0x1, opBAm0x1, opBBm0x1, opBCm0x1, opBDm0x1, opBEm0x1, opBFm0x1
dd opC0m0x1, opC1m0x1, opC2m0x1, opC3m0x1, opC4m0x1, opC5m0x1, opC6m0x1, opC7m0x1, opC8m0x1, opC9m0x1, opCAm0x1, opCBm0x1, opCCm0x1, opCDm0x1, opCEm0x1, opCFm0x1
dd opD0m0x1, opD1m0x1, opD2m0x1, opD3m0x1, opD4m0x1, opD5m0x1, opD6m0x1, opD7m0x1, opD8m0x1, opD9m0x1, opDAm0x1, opDBm0x1, opDCm0x1, opDDm0x1, opDEm0x1, opDFm0x1
dd opE0m0x1, opE1m0x1, opE2m0x1, opE3m0x1, opE4m0x1, opE5m0x1, opE6m0x1, opE7m0x1, opE8m0x1, opE9m0x1, opEAm0x1, opEBm0x1, opECm0x1, opEDm0x1, opEEm0x1, opEFm0x1
dd opF0m0x1, opF1m0x1, opF2m0x1, opF3m0x1, opF4m0x1, opF5m0x1, opF6m0x1, opF7m0x1, opF8m0x1, opF9m0x1, opFAm0x1, opFBm0x1, opFCm0x1, opFDm0x1, opFEm0x1, opFFm0x1

opcodetable_m1x0 dd op00m1x0, op01m1x0, op02m1x0, op03m1x0, op04m1x0, op05m1x0, op06m1x0, op07m1x0, op08m1x0, op09m1x0, op0Am1x0, op0Bm1x0, op0Cm1x0, op0Dm1x0, op0Em1x0, op0Fm1x0
dd op10m1x0, op11m1x0, op12m1x0, op13m1x0, op14m1x0, op15m1x0, op16m1x0, op17m1x0, op18m1x0, op19m1x0, op1Am1x0, op1Bm1x0, op1Cm1x0, op1Dm1x0, op1Em1x0, op1Fm1x0
dd op20m1x0, op21m1x0, op22m1x0, op23m1x0, op24m1x0, op25m1x0, op26m1x0, op27m1x0, op28m1x0, op29m1x0, op2Am1x0, op2Bm1x0, op2Cm1x0, op2Dm1x0, op2Em1x0, op2Fm1x0
dd op30m1x0, op31m1x0, op32m1x0, op33m1x0, op34m1x0, op35m1x0, op36m1x0, op37m1x0, op38m1x0, op39m1x0, op3Am1x0, op3Bm1x0, op3Cm1x0, op3Dm1x0, op3Em1x0, op3Fm1x0
dd op40m1x0, op41m1x0, op42m1x0, op43m1x0, op44m1x0, op45m1x0, op46m1x0, op47m1x0, op48m1x0, op49m1x0, op4Am1x0, op4Bm1x0, op4Cm1x0, op4Dm1x0, op4Em1x0, op4Fm1x0
dd op50m1x0, op51m1x0, op52m1x0, op53m1x0, op54m1x0, op55m1x0, op56m1x0, op57m1x0, op58m1x0, op59m1x0, op5Am1x0, op5Bm1x0, op5Cm1x0, op5Dm1x0, op5Em1x0, op5Fm1x0
dd op60m1x0, op61m1x0, op62m1x0, op63m1x0, op64m1x0, op65m1x0, op66m1x0, op67m1x0, op68m1x0, op69m1x0, op6Am1x0, op6Bm1x0, op6Cm1x0, op6Dm1x0, op6Em1x0, op6Fm1x0
dd op70m1x0, op71m1x0, op72m1x0, op73m1x0, op74m1x0, op75m1x0, op76m1x0, op77m1x0, op78m1x0, op79m1x0, op7Am1x0, op7Bm1x0, op7Cm1x0, op7Dm1x0, op7Em1x0, op7Fm1x0
dd op80m1x0, op81m1x0, op82m1x0, op83m1x0, op84m1x0, op85m1x0, op86m1x0, op87m1x0, op88m1x0, op89m1x0, op8Am1x0, op8Bm1x0, op8Cm1x0, op8Dm1x0, op8Em1x0, op8Fm1x0
dd op90m1x0, op91m1x0, op92m1x0, op93m1x0, op94m1x0, op95m1x0, op96m1x0, op97m1x0, op98m1x0, op99m1x0, op9Am1x0, op9Bm1x0, op9Cm1x0, op9Dm1x0, op9Em1x0, op9Fm1x0
dd opA0m1x0, opA1m1x0, opA2m1x0, opA3m1x0, opA4m1x0, opA5m1x0, opA6m1x0, opA7m1x0, opA8m1x0, opA9m1x0, opAAm1x0, opABm1x0, opACm1x0, opADm1x0, opAEm1x0, opAFm1x0
dd opB0m1x0, opB1m1x0, opB2m1x0, opB3m1x0, opB4m1x0, opB5m1x0, opB6m1x0, opB7m1x0, opB8m1x0, opB9m1x0, opBAm1x0, opBBm1x0, opBCm1x0, opBDm1x0, opBEm1x0, opBFm1x0
dd opC0m1x0, opC1m1x0, opC2m1x0, opC3m1x0, opC4m1x0, opC5m1x0, opC6m1x0, opC7m1x0, opC8m1x0, opC9m1x0, opCAm1x0, opCBm1x0, opCCm1x0, opCDm1x0, opCEm1x0, opCFm1x0
dd opD0m1x0, opD1m1x0, opD2m1x0, opD3m1x0, opD4m1x0, opD5m1x0, opD6m1x0, opD7m1x0, opD8m1x0, opD9m1x0, opDAm1x0, opDBm1x0, opDCm1x0, opDDm1x0, opDEm1x0, opDFm1x0
dd opE0m1x0, opE1m1x0, opE2m1x0, opE3m1x0, opE4m1x0, opE5m1x0, opE6m1x0, opE7m1x0, opE8m1x0, opE9m1x0, opEAm1x0, opEBm1x0, opECm1x0, opEDm1x0, opEEm1x0, opEFm1x0
dd opF0m1x0, opF1m1x0, opF2m1x0, opF3m1x0, opF4m1x0, opF5m1x0, opF6m1x0, opF7m1x0, opF8m1x0, opF9m1x0, opFAm1x0, opFBm1x0, opFCm1x0, opFDm1x0, opFEm1x0, opFFm1x0

opcodetable_m1x1 dd op00m1x1, op01m1x1, op02m1x1, op03m1x1, op04m1x1, op05m1x1, op06m1x1, op07m1x1, op08m1x1, op09m1x1, op0Am1x1, op0Bm1x1, op0Cm1x1, op0Dm1x1, op0Em1x1, op0Fm1x1
dd op10m1x1, op11m1x1, op12m1x1, op13m1x1, op14m1x1, op15m1x1, op16m1x1, op17m1x1, op18m1x1, op19m1x1, op1Am1x1, op1Bm1x1, op1Cm1x1, op1Dm1x1, op1Em1x1, op1Fm1x1
dd op20m1x1, op21m1x1, op22m1x1, op23m1x1, op24m1x1, op25m1x1, op26m1x1, op27m1x1, op28m1x1, op29m1x1, op2Am1x1, op2Bm1x1, op2Cm1x1, op2Dm1x1, op2Em1x1, op2Fm1x1
dd op30m1x1, op31m1x1, op32m1x1, op33m1x1, op34m1x1, op35m1x1, op36m1x1, op37m1x1, op38m1x1, op39m1x1, op3Am1x1, op3Bm1x1, op3Cm1x1, op3Dm1x1, op3Em1x1, op3Fm1x1
dd op40m1x1, op41m1x1, op42m1x1, op43m1x1, op44m1x1, op45m1x1, op46m1x1, op47m1x1, op48m1x1, op49m1x1, op4Am1x1, op4Bm1x1, op4Cm1x1, op4Dm1x1, op4Em1x1, op4Fm1x1
dd op50m1x1, op51m1x1, op52m1x1, op53m1x1, op54m1x1, op55m1x1, op56m1x1, op57m1x1, op58m1x1, op59m1x1, op5Am1x1, op5Bm1x1, op5Cm1x1, op5Dm1x1, op5Em1x1, op5Fm1x1
dd op60m1x1, op61m1x1, op62m1x1, op63m1x1, op64m1x1, op65m1x1, op66m1x1, op67m1x1, op68m1x1, op69m1x1, op6Am1x1, op6Bm1x1, op6Cm1x1, op6Dm1x1, op6Em1x1, op6Fm1x1
dd op70m1x1, op71m1x1, op72m1x1, op73m1x1, op74m1x1, op75m1x1, op76m1x1, op77m1x1, op78m1x1, op79m1x1, op7Am1x1, op7Bm1x1, op7Cm1x1, op7Dm1x1, op7Em1x1, op7Fm1x1
dd op80m1x1, op81m1x1, op82m1x1, op83m1x1, op84m1x1, op85m1x1, op86m1x1, op87m1x1, op88m1x1, op89m1x1, op8Am1x1, op8Bm1x1, op8Cm1x1, op8Dm1x1, op8Em1x1, op8Fm1x1
dd op90m1x1, op91m1x1, op92m1x1, op93m1x1, op94m1x1, op95m1x1, op96m1x1, op97m1x1, op98m1x1, op99m1x1, op9Am1x1, op9Bm1x1, op9Cm1x1, op9Dm1x1, op9Em1x1, op9Fm1x1
dd opA0m1x1, opA1m1x1, opA2m1x1, opA3m1x1, opA4m1x1, opA5m1x1, opA6m1x1, opA7m1x1, opA8m1x1, opA9m1x1, opAAm1x1, opABm1x1, opACm1x1, opADm1x1, opAEm1x1, opAFm1x1
dd opB0m1x1, opB1m1x1, opB2m1x1, opB3m1x1, opB4m1x1, opB5m1x1, opB6m1x1, opB7m1x1, opB8m1x1, opB9m1x1, opBAm1x1, opBBm1x1, opBCm1x1, opBDm1x1, opBEm1x1, opBFm1x1
dd opC0m1x1, opC1m1x1, opC2m1x1, opC3m1x1, opC4m1x1, opC5m1x1, opC6m1x1, opC7m1x1, opC8m1x1, opC9m1x1, opCAm1x1, opCBm1x1, opCCm1x1, opCDm1x1, opCEm1x1, opCFm1x1
dd opD0m1x1, opD1m1x1, opD2m1x1, opD3m1x1, opD4m1x1, opD5m1x1, opD6m1x1, opD7m1x1, opD8m1x1, opD9m1x1, opDAm1x1, opDBm1x1, opDCm1x1, opDDm1x1, opDEm1x1, opDFm1x1
dd opE0m1x1, opE1m1x1, opE2m1x1, opE3m1x1, opE4m1x1, opE5m1x1, opE6m1x1, opE7m1x1, opE8m1x1, opE9m1x1, opEAm1x1, opEBm1x1, opECm1x1, opEDm1x1, opEEm1x1, opEFm1x1
dd opF0m1x1, opF1m1x1, opF2m1x1, opF3m1x1, opF4m1x1, opF5m1x1, opF6m1x1, opF7m1x1, opF8m1x1, opF9m1x1, opFAm1x1, opFBm1x1, opFCm1x1, opFDm1x1, opFEm1x1, opFFm1x1


_temp dd ?

;_DATA ENDS

;_TEXT SEGMENT DWORD PUBLIC USE32 'CODE'
;	ASSUME CS:_TEXT, DS:_DATA
.code

extrn _trapregread:near
extrn _trapregwrite:near



public _doemulate

; Register Usage
; EAX: Anything
; EBX: Starts off containing opdata (BL=opcode)
; ECX: CL: Processor Status (P)
; EDX: Program Counter
; ESI: Cycles until routine exit
; EDI: Anything
; EBP: Temporary storage
; Carry: set if M/X changed at end of instruction execution

_doemulate proc near C
	push eax
	push ebx
	push ecx
	push edx
	push esi
	push edi
	push ebp

	mov edx, [_reg.PC]
	mov cl,  [_reg.P]
	mov esi, [_scan_cycles]
	
looptop_check:
	test esi, 80000000h ; Negative number?
	jnz exitroutine

looptop:
	test cl, 10h  ; Index
	jz indexis16  ; x0=16bit
indexis8:
	test cl, 20h  ; Memory
	jz  loop_m0x1 ; m0=16bit
	jmp loop_m1x1
indexis16:
	test cl, 20h  ; Memory
	jnz loop_m1x0 ; m1=8bit

loop_m0x0:
	mainloop opcodetable_m0x0
loop_m0x1:
	mainloop opcodetable_m0x1
loop_m1x0:
	mainloop opcodetable_m1x0
loop_m1x1:
	mainloop opcodetable_m1x1

exitroutine:
	mov byte  [_reg.P], cl
	mov dword [_reg.PC], edx
	mov dword [_scan_cycles], esi
	pop ebp
	pop edi
	pop esi
	pop edx
	pop ecx
	pop ebx
	pop eax
	ret

;****************************************************************************
;                        START OF EMULATION ROUTINES
;****************************************************************************

op00m0x0: ; "BRK", 2, 8,
op00m0x1:
op00m1x0:
op00m1x1:
	docount 2, 8
	vectorcall 00FFFEh, 00FFE6h
	dobreak
op01m0x0: ;	"ORA (<%b,X)", 2, 6,
	load_dir_index_indir_x16
	docount 2, 6+1
	ora16
	dobreak
op01m0x1:
	load_dir_index_indir_x8
	docount 2, 6+1
	ora16
	dobreak
op01m1x0:
	load_dir_index_indir_x16
	docount 2, 6
	ora8
	dobreak
op01m1x1:
	load_dir_index_indir_x8
	docount 2, 6
	ora8
	dobreak
op02m0x0: ;	"CSP", 2, 8,
op02m0x1:
op02m1x0:
op02m1x1:
	or  cl, FINTERRUPT
	docount 2, 8
	and cl, 0FFh-FDECIMAL
	vectorcall 00FFF4h, 00FFE4h
	dobreak
op03m0x0: ;	"ORA <%b,s", 2, 4,
op03m0x1:
	load_s_rel
	docount 2, 4+1
	ora16	
	dobreak
op03m1x0:
op03m1x1:
	load_s_rel
	docount 2, 4
	ora8
	dobreak
op04m0x0: ;	"TSB <%b", 2, 5,
op04m0x1:
	load_dir
	docount 2, 5+1
	tsb16
	dobreak
op04m1x0:
op04m1x1:
	load_dir
	docount 2, 5
	tsb8
	dobreak
op05m0x0: ;	"ORA <%b", 2, 3,
op05m0x1:
	load_dir
	docount 2, 3+1
	ora16
	dobreak
op05m1x0:
op05m1x1:
	load_dir
	docount 2, 3
	ora8
	dobreak
op06m0x0: ;	"SHL <%b", 2, 5,
op06m0x1:
	load_dir
	docount 2, 5+1
	shl16
	dobreak
op06m1x0:
op06m1x1:
	load_dir
	docount 2, 5
	shl8
	dobreak
op07m0x0: ;	"ORA [<%b]", 2, 6,
op07m0x1:
	load_dir_indir_long
	docount 2, 6+1
	ora16
	dobreak
op07m1x0:
op07m1x1:
	load_dir_indir_long
	docount 2, 6
	ora8
	dobreak
op08m0x0: ;	"PSH P", 1, 3, // PHP
op08m0x1:
op08m1x0:
op08m1x1:
	pushbyte cl
	docount 1, 3
	dobreak
op09m0x0: ;	"ORA %#", 2(+1), 2,
op09m0x1:
	get_imm
	docount 2+1, 2+1
	ora16 imm
	dobreak
op09m1x0:
op09m1x1:
	get_imm
	docount 2, 2
	ora8 imm
	dobreak
op0Am0x0: ;	"SHL A", 1, 2,
op0Am0x1:
	docount 1, 2
	shl16_a
	dobreak
op0Am1x0:
op0Am1x1:
	docount 1, 2
	shl8_a
	dobreak
op0Bm0x0: ;	"PSH D", 1, 4, // PHD Push Direct
op0Bm0x1:
op0Bm1x0:
op0Bm1x1:
	mov ebx, dword [_reg.D]
	docount 1, 4
	pushbyte bh
	pushbyte bl
	dobreak
op0Cm0x0: ;	"TSB %w", 3, 6,
op0Cm0x1:
	load_abs
	docount 3, 6+1
	tsb16
	dobreak
op0Cm1x0:
op0Cm1x1:
	load_abs
	docount 3, 6
	tsb8
	dobreak
op0Dm0x0: ;	"ORA %w", 3, 4,
op0Dm0x1:
	load_abs
	docount 3, 4+1
	ora16
	dobreak
op0Dm1x0:
op0Dm1x1:
	load_abs
	docount 3, 4
	ora8
	dobreak
op0Em0x0: ;	"SHL %w", 3, 6,
op0Em0x1:
	load_abs
	docount 3, 6+1
	shl16
	dobreak
op0Em1x0:
op0Em1x1:
	load_abs
	docount 3, 6
	shl8
	dobreak
op0Fm0x0: ;	"ORA %L", 4, 5,
op0Fm0x1:
	load_abs_long
	docount 4, 5+1
	ora16
	dobreak
op0Fm1x0:
op0Fm1x1:
	load_abs_long
	docount 4, 5
	ora8
	dobreak
op10m0x0: ;	"BPL @%b", 2, 2,
op10m0x1:
op10m1x0:
op10m1x1:
	add edx, 2    ; PC += 2
	test cl, FNEGATIVE
	jz @F         ; Branch
	sub esi, 2    ; cycle count
	dobreak
@@:	movsx ebx, bh
	sub esi, 3    ; cycle count
	add dx, bx
	dobreak
op11m0x0: ;	"ORA (<%b),Y", 2, 5,
	load_dir_indir_index_y16
	docount 2, 5+1
	ora16
	dobreak
op11m0x1:
	load_dir_indir_index_y8
	docount 2, 5+1
	ora16
	dobreak
op11m1x0:
	load_dir_indir_index_y16
	docount 2, 5
	ora8
	dobreak
op11m1x1:
	load_dir_indir_index_y8
	docount 2, 5
	ora8
	dobreak
op12m0x0: ;	"ORA (<%b)", 2, 5,
op12m0x1:
	load_dir_indir
	docount 2, 5+1
	ora16
	dobreak
op12m1x0:
op12m1x1:
	load_dir_indir
	docount 2, 5
	ora8
	dobreak
op13m0x0: ;	"ORA (<%b,S),Y", 2, 7,
	load_s_rel_indir_index_y16
	docount 2, 7+1
	ora16
	dobreak
op13m0x1:
	load_s_rel_indir_index_y8
	docount 2, 7+1
	ora16
	dobreak
op13m1x0:
	load_s_rel_indir_index_y16
	docount 2, 7
	ora8
	dobreak
op13m1x1:
	load_s_rel_indir_index_y8
	docount 2, 7
	ora8
	dobreak
op14m0x0: ;	"TRB <%b", 2, 5,
op14m0x1:
	load_dir
	docount 2, 5+1
	trb16
	dobreak
op14m1x0:
op14m1x1:
	load_dir
	docount 2, 5
	trb8
	dobreak
op15m0x0: ;	"ORA <%b,X", 2, 4,
	load_dir_index_x16
	docount 2, 4+1
	ora16
	dobreak
op15m0x1:
	load_dir_index_x8
	docount 2, 4+1
	ora16
	dobreak
op15m1x0:
	load_dir_index_x16
	docount 2, 4
	ora8
	dobreak
op15m1x1:
	load_dir_index_x8
	docount 2, 4
	ora8
	dobreak
op16m0x0: ;	"SHL <%b,X",2, 6,
	load_dir_index_x16
	docount 2, 6+1
	shl16
	dobreak
op16m0x1:
	load_dir_index_x8
	docount 2, 6+1
	shl16
	dobreak
op16m1x0:
	load_dir_index_x16
	docount 2, 6
	shl8
	dobreak
op16m1x1:
	load_dir_index_x8
	docount 2, 6
	shl8
	dobreak
op17m0x0: ;	"ORA [<%b],Y", 2, 6,
	load_dir_indir_long_index_y16
	docount 2, 6+1
	ora16
	dobreak
op17m0x1:
	load_dir_indir_long_index_y8
	docount 2, 6+1
	ora16
	dobreak
op17m1x0:
	load_dir_indir_long_index_y16
	docount 2, 6
	ora8
	dobreak
op17m1x1:
	load_dir_indir_long_index_y8
	docount 2, 6
	ora8
	dobreak
op18m0x0: ;	"CLC", 1, 2,
op18m0x1:
op18m1x0:
op18m1x1:
	and cl, 0FFh-FCARRY
	docount 1, 2
	dobreak;
op19m0x0: ;	"ORA %w,Y", 3, 4,
	load_abs_index_y16
	docount 3, 4+1
	ora16
	dobreak
op19m0x1:
	load_abs_index_y8
	docount 3, 4+1
	ora16
	dobreak
op19m1x0:
	load_abs_index_y16
	docount 3, 4
	ora8
	dobreak
op19m1x1:
	load_abs_index_y8
	docount 3, 4
	ora8
	dobreak
op1Am0x0: ;	"INC A", 1, 2,
op1Am0x1:
	docount 1, 2
	inca16
	dobreak
op1Am1x0:
op1Am1x1:
	docount 1, 2
	inca8
	dobreak
op1Bm0x0: ;	"TAS", 1, 2,
op1Bm0x1:
op1Bm1x0:
op1Bm1x1:
	mov eax, dword [_reg.A]
	docount 1, 2
	mov dword [_reg.S], eax
	dobreak;
op1Cm0x0: ;	"TRB %w", 3, 6,
op1Cm0x1:
	load_abs
	docount 3, 6+1
	trb16
	dobreak
op1Cm1x0:
op1Cm1x1:
	load_abs
	docount 3, 6
	trb8
	dobreak
op1Dm0x0: ;	"ORA %w,X", 3, 4,
	load_abs_index_x16
	docount 3, 4+1
	ora16
	dobreak
op1Dm0x1:
	load_abs_index_x8
	docount 3, 4+1
	ora16
	dobreak
op1Dm1x0:
	load_abs_index_x16
	docount 3, 4
	ora8
	dobreak
op1Dm1x1:
	load_abs_index_x8
	docount 3, 4
	ora8
	dobreak
op1Em0x0: ;	"SHL %w,X", 3, 7,
	load_abs_index_x16
	docount 3, 7+1
	shl16
	dobreak
op1Em0x1:
	load_abs_index_x8
	docount 3, 7+1
	shl16
	dobreak
op1Em1x0:
	load_abs_index_x16
	docount 3, 7
	shl8
	dobreak
op1Em1x1:
	load_abs_index_x8
	docount 3, 7
	shl8
	dobreak
op1Fm0x0: ;	"ORA %L,X", 4, 5,
	load_abs_long_index_x16
	docount 4, 5+1
	ora16
	dobreak
op1Fm0x1:
	load_abs_long_index_x8
	docount 4, 5+1
	ora16
	dobreak
op1Fm1x0:
	load_abs_long_index_x16
	docount 4, 5
	ora8
	dobreak
op1Fm1x1:
	load_abs_long_index_x8
	docount 4, 5
	ora8
	dobreak
op20m0x0: ;	"JSR %w", 3, 6,
op20m0x1:
op20m1x0:
op20m1x1:
	shr ebx, 8
	docount 2, 6 ; 1 less
	shortcall bl, bh
	dobreak
op21m0x0: ;	"AND (<%b,X)", 2, 6,
	load_dir_index_indir_x16
	docount 2, 6+1
	and16
	dobreak
op21m0x1:
	load_dir_index_indir_x8
	docount 2, 6+1
	and16
	dobreak
op21m1x0:
	load_dir_index_indir_x16
	docount 2, 6
	and8
	dobreak
op21m1x1:
	load_dir_index_indir_x8
	docount 2, 6
	and8
	dobreak
op22m0x0: ;	"JSL %L", 4, 8,
op22m0x1:
op22m1x0:
op22m1x1:
	shr ebx, 8
	docount 3, 8 ; 1 less
	longcall_ebx
	dobreak
op23m0x0: ;	"AND <%b,s", 2, 4,
op23m0x1:
	load_s_rel
	docount 2, 4+1
	and16
	dobreak
op23m1x0:
op23m1x1:
	load_s_rel
	docount 2, 4
	and8
	dobreak
op24m0x0: ;	"BIT <%b", 2, 3,
op24m0x1:
	load_dir
	docount 2, 3+1
	bit16
	dobreak
op24m1x0:
op24m1x1:
	load_dir
	docount 2, 3
	bit8
	dobreak
op25m0x0: ;	"AND <%b", 2, 3,
op25m0x1:
	load_dir
	docount 2, 3+1
	and16
	dobreak
op25m1x0:
op25m1x1:
	load_dir
	docount 2, 3
	and8
	dobreak
op26m0x0: ;	"ROL <%b", 2, 5,
op26m0x1:
	load_dir
	docount 2, 5
	rol16
	dobreak
op26m1x0:
op26m1x1:
	load_dir
	docount 2, 5
	rol8
	dobreak
op27m0x0: ;	"AND [<%b]", 2, 6,
op27m0x1:
	load_dir_indir_long
	docount 2, 6+1
	and16
	dobreak
op27m1x0:
op27m1x1:
	load_dir_indir_long
	docount 2, 6
	and8
	dobreak
op28m0x0: ;	"PUL P", 1, 4, // PLP
op28m0x1:
op28m1x0:
op28m1x1:
	pullbyte cl
	docount 1, 4
	test cl, 10h  ; 8-bit index?
	jz @F
	and dword [_reg.X], 0FFh ; clear high bytes
	and dword [_reg.Y], 0FFh
@@:	dobreak_mxchange
op29m0x0: ;	"AND %#", 2, 2,
op29m0x1:
	get_imm
	docount 2+1, 2+1
	and16 imm
	dobreak
op29m1x0:
op29m1x1:
	get_imm
	docount 2, 2
	and8 imm
	dobreak
op2Am0x0: ;	"ROL A", 1, 2,
op2Am0x1:
	docount 1, 2
	rol16_a
	dobreak
op2Am1x0:
op2Am1x1:
	docount 1, 2
	rol8_a
	dobreak
op2Bm0x0: ;	"PUL D", 1, 5, // PLD Pull Direct
op2Bm0x1:
op2Bm1x0:
op2Bm1x1:
	pullbyte bl
	pullbyte bh
	and cl, 0FFh-FZERO-FNEGATIVE
	inc edx
	and ebx, 0000FFFFh
	jnz @F
	or cl, FZERO
@@:	test bh, 80h
	jz @F
	or cl, FNEGATIVE
@@:	sub esi, 5
	mov dword [_reg.D], ebx
	dobreak
op2Cm0x0: ;	"BIT %w", 3, 4,
op2Cm0x1:
	load_abs
	docount 3, 4+1
	bit16
	dobreak
op2Cm1x0:
op2Cm1x1:
	load_abs
	docount 3, 4
	bit8
	dobreak
op2Dm0x0: ;	"AND %w", 3, 4,
op2Dm0x1:
	load_abs
	docount 3, 4+1
	and16
	dobreak
op2Dm1x0:
op2Dm1x1:
	load_abs
	docount 3, 4
	and8
	dobreak
op2Em0x0: ;	"ROL %w", 3, 6,
op2Em0x1:
	load_abs
	docount 3, 6+1
	rol16
	dobreak
op2Em1x0:
op2Em1x1:
	load_abs
	docount 3, 6
	rol8
	dobreak
op2Fm0x0: ;	"AND %L", 4, 5,
op2Fm0x1:
	load_abs_long
	docount 4, 5+1
	and16
	dobreak
op2Fm1x0:
op2Fm1x1:
	load_abs_long
	docount 4, 5
	and8
	dobreak
op30m0x0: ;	"BMI @%b", 2, 2,
op30m0x1:
op30m1x0:
op30m1x1:
	add edx, 2   ; PC += 2
	test cl, FNEGATIVE
	jnz @F       ; Branch
	sub esi, 2   ; cycle count
	dobreak
@@: shr ebx, 8
	sub esi, 3   ; cycle count
	movsx ebx, bl ; signed byte
	add dx, bx
	dobreak
op31m0x0: ;	"AND (<%b),Y", 2, 5,
	load_dir_indir_index_y16
	docount 2, 5+1
	and16
	dobreak
op31m0x1:
	load_dir_indir_index_y8
	docount 2, 5+1
	and16
	dobreak
op31m1x0:
	load_dir_indir_index_y16
	docount 2, 5
	and8
	dobreak
op31m1x1:
	load_dir_indir_index_y8
	docount 2, 5
	and8
	dobreak
op32m0x0: ;	"AND (<%b)", 2, 5,
op32m0x1:
	load_dir_indir
	docount 2, 5+1
	and16
	dobreak
op32m1x0:
op32m1x1:
	load_dir_indir
	docount 2, 5
	and8
	dobreak
op33m0x0: ;	"AND (<%b,s),Y", 2, 7,
	load_s_rel_indir_index_y16
	docount 2, 7+1
	and16
	dobreak
op33m0x1:
	load_s_rel_indir_index_y8
	docount 2, 7+1
	and16
	dobreak
op33m1x0:
	load_s_rel_indir_index_y16
	docount 2, 7
	and8
	dobreak
op33m1x1:
	load_s_rel_indir_index_y8
	docount 2, 7
	and8
	dobreak
op34m0x0: ;	"BIT <%b,X", 2, 4,
	load_dir_index_x16
	docount 2, 4+1
	bit16
	dobreak
op34m0x1:
	load_dir_index_x8
	docount 2, 4+1
	bit16
	dobreak
op34m1x0:
	load_dir_index_x16
	docount 2, 4
	bit8
	dobreak
op34m1x1:
	load_dir_index_x8
	docount 2, 4
	bit8
	dobreak
op35m0x0: ;	"AND <%b,X", 2, 4,
	load_dir_index_x16
	docount 2, 4+1
	and16
	dobreak
op35m0x1:
	load_dir_index_x8
	docount 2, 4+1
	and16
	dobreak
op35m1x0:
	load_dir_index_x16
	docount 2, 4
	and8
	dobreak
op35m1x1:
	load_dir_index_x8
	docount 2, 4
	and8
	dobreak
op36m0x0: ;	"ROL <%b,X", 2, 6,
	load_dir_index_x16
	docount 2, 6+1
	rol16
	dobreak
op36m0x1:
	load_dir_index_x8
	docount 2, 6+1
	rol16
	dobreak
op36m1x0:
	load_dir_index_x16
	docount 2, 6
	rol8
	dobreak
op36m1x1:
	load_dir_index_x8
	docount 2, 6
	rol8
	dobreak
op37m0x0: ;	"AND [<%b],Y", 2, 6,
	load_dir_indir_long_index_y16
	docount 2, 6+1
	and16
	dobreak
op37m0x1:
	load_dir_indir_long_index_y8
	docount 2, 6+1
	and16
	dobreak
op37m1x0:
	load_dir_indir_long_index_y16
	docount 2, 6
	and8
	dobreak
op37m1x1:
	load_dir_indir_long_index_y8
	docount 2, 6
	and8
	dobreak
op38m0x0: ;	"SEC", 1, 2,
op38m0x1:
op38m1x0:
op38m1x1:
	or  cl, FCARRY
	docount 1, 2
	dobreak
op39m0x0: ;	"AND %w,Y", 3, 4,
	load_abs_index_y16
	docount 3, 4+1
	and16
	dobreak
op39m0x1:
	load_abs_index_y8
	docount 3, 4+1
	and16
	dobreak
op39m1x0:
	load_abs_index_y16
	docount 3, 4
	and8
	dobreak
op39m1x1:
	load_abs_index_y8
	docount 3, 4
	and8
	dobreak
op3Am0x0: ;	"DEC A", 1, 2,
op3Am0x1:
	docount 1, 2
	deca16
	dobreak
op3Am1x0:
op3Am1x1:
	docount 1, 2
	deca8
	dobreak
op3Bm0x0: ;	"TSA", 1, 2,
op3Bm0x1:
op3Bm1x0:
op3Bm1x1:
	mov eax, dword [_reg.S]
	docount 1, 2
	mov dword [_reg.A], eax
	and cl, 0FFh-FNEGATIVE-FZERO
	test eax, eax
	jnz @F
	or  cl, FZERO
@@:	test ah, 80h
	jz @F
	or cl, FNEGATIVE
@@:	dobreak
op3Cm0x0: ;	"BIT %w,X", 3, 4,
	load_abs_index_x16
	docount 3, 4+1
	bit16
	dobreak
op3Cm0x1:
	load_abs_index_x8
	docount 3, 4+1
	bit16
	dobreak
op3Cm1x0:
	load_abs_index_x16
	docount 3, 4
	bit8
	dobreak
op3Cm1x1:
	load_abs_index_x8
	docount 3, 4
	bit8
	dobreak
op3Dm0x0: ;	"AND %w,X", 3, 4,
	load_abs_index_x16
	docount 3, 4+1
	and16
	dobreak
op3Dm0x1:
	load_abs_index_x8
	docount 3, 4+1
	and16
	dobreak
op3Dm1x0:
	load_abs_index_x16
	docount 3, 4
	and8
	dobreak
op3Dm1x1:
	load_abs_index_x8
	docount 3, 4
	and8
	dobreak
op3Em0x0: ;	"ROL %w,X", 3, 7,
	load_abs_index_x16
	docount 3, 7+1
	rol16
	dobreak
op3Em0x1:
	load_abs_index_x8
	docount 3, 7+1
	rol16
	dobreak
op3Em1x0:
	load_abs_index_x16
	docount 3, 7
	rol8
	dobreak
op3Em1x1:
	load_abs_index_x8
	docount 3, 7
	rol8
	dobreak
op3Fm0x0: ;	"AND %L,X", 4, 5,
	load_abs_long_index_x16
	docount 4, 5+1
	and16
	dobreak
op3Fm0x1:
	load_abs_long_index_x8
	docount 4, 5+1
	and16
	dobreak
op3Fm1x0:
	load_abs_long_index_x16
	docount 4, 5
	and8
	dobreak
op3Fm1x1:
	load_abs_long_index_x8
	docount 4, 5
	and8
	dobreak
op40m0x0: ;	"RTI", 1, 7,
op40m0x1:
op40m1x0:
op40m1x1:
	pullbyte cl
	test cl, 10h  ; 8-bit index?
	jz @F
	and dword [_reg.X], 0FFh ; clear high bytes
	and dword [_reg.Y], 0FFh
@@:	xor ebx, ebx
	pullbyte bl
	xor edx, edx
	pullbyte bh
	pullbyte dl
	shl edx, 16
	sub esi, 7
	or  edx, ebx
	dobreak_mxchange
op41m0x0: ;	"XOR (<%b,X)", 2, 6,
	load_dir_index_indir_x16
	docount 2, 6+1
	xor16
	dobreak
op41m0x1:
	load_dir_index_indir_x8
	docount 2, 6+1
	xor16
	dobreak
op41m1x0:
	load_dir_index_indir_x16
	docount 2, 6
	xor8
	dobreak
op41m1x1:
	load_dir_index_indir_x8
	docount 2, 6
	xor8
	dobreak
op42m0x0: ;	"???", 2, 2, (WDM)
op42m0x1:
op42m1x0:
op42m1x1:
	docount 2, 2
	dobreak
op43m0x0: ;	"XOR <%b,s", 2, 4,
op43m0x1:
	load_s_rel
	docount 2, 4+1
	xor16
	dobreak
op43m1x0:
op43m1x1:
	load_s_rel
	docount 2, 4
	xor8
	dobreak
op44m0x0: ;	"MVP XYA %w", 3, 7,
op44m1x0:
	; EBX:  BL  BH  3rd  4th
	;       opc dst src        (dbr<<16)+y = (src&0xFF0000)+x
	mov byte [_reg.DBR], bh
	sub esi, 7
	and ebx, 00FF0000h               ; Source
	mov edi, dword [_reg.DBR_2less]  ; Destination
	or  ebx, dword [_reg.X]
	or  edi, dword [_reg.Y]
	convert_snesptr ebx
	convert_snesptr edi
	trapandread8 ebx
	trapandwrite8 edi, bl
	dec_word [_reg.A]
	dec_word [_reg.X]
	dec_word [_reg.Y]
	cmp dword [_reg.A], 0000FFFFh
	jne @F
	add edx, 3
@@: dobreak
op44m0x1:
op44m1x1:
	; EBX:  BL  BH  3rd  4th
	;       opc dst src        (dbr<<16)+y = (src&0xFF0000)+x
	mov byte [_reg.DBR], bh
	sub esi, 7
	and ebx, 00FF0000h               ; Source
	mov edi, dword [_reg.DBR_2less]  ; Destination
	movzx eax,byte [_reg.Y]
	or  bl,   byte [_reg.X]
	or  edi, eax
	convert_snesptr ebx
	convert_snesptr edi
	trapandread8 ebx
	trapandwrite8 edi, bl
	dec_word [_reg.A]
	dec byte [_reg.X]
	dec byte [_reg.Y]
	cmp dword [_reg.A], 0000FFFFh
	jne @F
	add edx, 3
@@: dobreak
op45m0x0: ;	"XOR <%b", 2, 3,
op45m0x1:
	load_dir
	docount 2, 3+1
	xor16
	dobreak
op45m1x0:
op45m1x1:
	load_dir
	docount 2, 3
	xor8
	dobreak
op46m0x0: ;	"SHR <%b", 2, 5,
op46m0x1:
	load_dir
	docount 2, 5+1
	shr16
	dobreak
op46m1x0:
op46m1x1:
	load_dir
	docount 2, 5
	shr8
	dobreak
op47m0x0: ;	"XOR [<%b]", 2, 6,
op47m0x1:
	load_dir_indir_long
	docount 2, 6+1
	xor16
	dobreak
op47m1x0:
op47m1x1:
	load_dir_indir_long
	docount 2, 6
	xor8
	dobreak
op48m0x0: ;	"PSH A", 1, 3, // PHA
op48m0x1:
	mov ebx, dword [_reg.A]
	docount 1, 3+1
	pushbyte bh
	pushbyte bl
	dobreak
op48m1x0:
op48m1x1:
	mov bl, byte [_reg.A]
	docount 1, 3
	pushbyte bl
	dobreak
op49m0x0: ;	"XOR %#", 2, 2,
op49m0x1:
	get_imm
	docount 2+1, 2+1
	xor16 imm
	dobreak
op49m1x0:
op49m1x1:
	get_imm
	docount 2, 2
	xor8 imm
	dobreak
op4Am0x0: ;	"SHR A", 1, 2,
op4Am0x1:
	docount 1, 2
	shr16_a
	dobreak
op4Am1x0:
op4Am1x1:
	docount 1, 2
	shr8_a
	dobreak
op4Bm0x0: ;	"PSH PBR", 1, 3, // PHK
op4Bm0x1:
op4Bm1x0:
op4Bm1x1:
	mov ebx, edx
	inc edx
	shr ebx, 16
	sub esi, 3
	pushbyte bl
	dobreak
op4Cm0x0: ;	"JMP %w", 3, 3,
op4Cm0x1:
op4Cm1x0:
op4Cm1x1:
	shr ebx, 8
	and edx, 00FF0000h
	and ebx, 0000FFFFh
	sub esi, 3
	or  edx, ebx
	dobreak
op4Dm0x0: ;	"XOR %w", 3, 4,
op4Dm0x1:
	load_abs
	docount 3, 4+1
	xor16
	dobreak
op4Dm1x0:
op4Dm1x1:
	load_abs
	docount 3, 4
	xor8
	dobreak
op4Em0x0: ;	"SHR %w", 3, 6,
op4Em0x1:
	load_abs
	docount 3, 6+1
	shr16
	dobreak
op4Em1x0:
op4Em1x1:
	load_abs
	docount 3, 6
	shr8
	dobreak
op4Fm0x0: ;	"XOR %L", 4, 5,
op4Fm0x1:
	load_abs_long
	docount 4, 5+1
	xor16
	dobreak
op4Fm1x0:
op4Fm1x1:
	load_abs_long
	docount 4, 5
	xor8
	dobreak
op50m0x0: ;	"BVC @%b", 2, 2,
op50m0x1:
op50m1x0:
op50m1x1:
	add edx, 2   ; PC += 2
	test cl, FOVERFLOW
	jz @F        ; Branch
	sub esi, 2   ; cycle count
	dobreak
@@: movsx ebx, bh ; signed byte
	sub esi, 3   ; cycle count
	add dx, bx
	dobreak
op51m0x0: ;	"XOR (<%b),Y", 2, 5,
	load_dir_indir_index_y16
	docount 2, 5+1
	xor16
	dobreak
op51m0x1:
	load_dir_indir_index_y8
	docount 2, 5+1
	xor16
	dobreak
op51m1x0:
	load_dir_indir_index_y16
	docount 2, 5
	xor8
	dobreak
op51m1x1:
	load_dir_indir_index_y8
	docount 2, 5
	xor8
	dobreak
op52m0x0: ;	"XOR (<%b)", 2, 5,
op52m0x1:
	load_dir_indir
	docount 2, 5+1
	xor16
	dobreak
op52m1x0:
op52m1x1:
	load_dir_indir
	docount 2, 5
	xor8
	dobreak
op53m0x0: ;	"XOR (<%b,s),Y", 2, 7,
	load_s_rel_indir_index_y16
	docount 2, 7+1
	xor16
	dobreak
op53m0x1:
	load_s_rel_indir_index_y8
	docount 2, 7+1
	xor16
	dobreak
op53m1x0:
	load_s_rel_indir_index_y16
	docount 2, 7
	xor8
	dobreak
op53m1x1:
	load_s_rel_indir_index_y8
	docount 2, 7
	xor8
	dobreak
op54m0x0: ;	"MVN XYA %w", 3, 7,
op54m1x0:
	; EBX:  BL  BH  3rd  4th
	;       opc dst src        (dbr<<16)+y = (src&0xFF0000)+x
	mov byte [_reg.DBR], bh
	sub esi, 7
	and ebx, 00FF0000h               ; Source
	mov edi, dword [_reg.DBR_2less]  ; Destination
	or  ebx, dword [_reg.X]
	or  edi, dword [_reg.Y]
	convert_snesptr ebx
	convert_snesptr edi
	trapandread8 ebx
	trapandwrite8 edi, bl
	dec_word [_reg.A]
	inc_word [_reg.X]
	inc_word [_reg.Y]
	cmp dword [_reg.A], 0000FFFFh
	jne @F
	add edx, 3
@@: dobreak
op54m0x1:
op54m1x1:
	; EBX:  BL  BH  3rd  4th
	;       opc dst src        (dbr<<16)+y = (src&0xFF0000)+x
	mov byte [_reg.DBR], bh
	sub esi, 7
	and ebx, 00FF0000h               ; Source
	mov edi, dword [_reg.DBR_2less]  ; Destination
	movzx eax,byte [_reg.Y]
	or  bl,   byte [_reg.X]
	or  edi, eax
	convert_snesptr ebx
	convert_snesptr edi
	trapandread8 ebx
	trapandwrite8 edi, bl
	dec_word [_reg.A]
	inc byte [_reg.X]
	inc byte [_reg.Y]
	cmp dword [_reg.A], 0000FFFFh
	jne @F
	add edx, 3
@@: dobreak
op55m0x0: ;	"XOR <%b,X", 2, 4,
	load_dir_index_x16
	docount 2, 4+1
	xor16
	dobreak
op55m0x1:
	load_dir_index_x8
	docount 2, 4+1
	xor16
	dobreak
op55m1x0:
	load_dir_index_x16
	docount 2, 4
	xor8
	dobreak
op55m1x1:
	load_dir_index_x8
	docount 2, 4
	xor8
	dobreak
op56m0x0: ;	"SHR <%b,X", 2, 6,
	load_dir_index_x16
	docount 2, 6+1
	shr16
	dobreak
op56m0x1:
	load_dir_index_x8
	docount 2, 6+1
	shr16
	dobreak
op56m1x0:
	load_dir_index_x16
	docount 2, 6
	shr8
	dobreak
op56m1x1:
	load_dir_index_x8
	docount 2, 6
	shr8
	dobreak
op57m0x0: ;	"XOR [<%b],Y", 2, 6,
	load_dir_indir_long_index_y16
	docount 2, 6+1
	xor16
	dobreak
op57m0x1:
	load_dir_indir_long_index_y8
	docount 2, 6+1
	xor16
	dobreak
op57m1x0:
	load_dir_indir_long_index_y16
	docount 2, 6
	xor8
	dobreak
op57m1x1:
	load_dir_indir_long_index_y8
	docount 2, 6
	xor8
	dobreak
op58m0x0: ;	"CLI", 1, 2,
op58m0x1:
op58m1x0:
op58m1x1:
	and cl, 0FFh-FINTERRUPT
	docount 1, 2
	dobreak
op59m0x0: ;	"XOR %w,Y", 3, 4,
	load_abs_index_y16
	docount 3, 4+1
	xor16
	dobreak
op59m0x1:
	load_abs_index_y8
	docount 3, 4+1
	xor16
	dobreak
op59m1x0:
	load_abs_index_y16
	docount 3, 4
	xor8
	dobreak
op59m1x1:
	load_abs_index_y8
	docount 3, 4
	xor8
	dobreak
op5Am0x0: ;	"PSH Y", 1, 3, // PHY
op5Am1x0:
	mov ebx, dword [_reg.Y]
	docount 1, 3+1
	pushbyte bh
	pushbyte bl
	dobreak
op5Am0x1:
op5Am1x1:
	mov bl, byte [_reg.Y]
	docount 1, 3
	pushbyte bl
	dobreak
op5Bm0x0: ;	"TAD", 1, 2,
op5Bm0x1:
op5Bm1x0:
op5Bm1x1:
	mov eax, dword [_reg.A]
	and ecx, 000000FFh-FZERO-FNEGATIVE ; clear ch as well
	test eax, eax
	jnz @F
	mov ch, FZERO ; Doesn't affect sign flag
@@:	mov dword [_reg.D], eax
	test ah, 80h
	jz @F
	or  cl, FNEGATIVE
@@: docount 1, 2
	or  cl, ch
	dobreak
op5Cm0x0: ;	"JML %L", 4, 4,
op5Cm0x1:
op5Cm1x0:
op5Cm1x1:
	shr ebx, 8
	sub esi, 4
	mov edx, ebx
	dobreak
op5Dm0x0: ;	"XOR %w,X", 3, 4,
	load_abs_index_x16
	docount 3, 4+1
	xor16
	dobreak
op5Dm0x1:
	load_abs_index_x8
	docount 3, 4+1
	xor16
	dobreak
op5Dm1x0:
	load_abs_index_x16
	docount 3, 4
	xor8
	dobreak
op5Dm1x1:
	load_abs_index_x8
	docount 3, 4
	xor8
	dobreak
op5Em0x0: ;	"SHR %w,X", 3, 7,
	load_abs_index_x16
	docount 3, 7+1
	shr16
	dobreak
op5Em0x1:
	load_abs_index_x8
	docount 3, 7+1
	shr16
	dobreak
op5Em1x0:
	load_abs_index_x16
	docount 3, 7
	shr8
	dobreak
op5Em1x1:
	load_abs_index_x8
	docount 3, 7
	shr8
	dobreak
op5Fm0x0: ;	"XOR %L,X", 4, 5,
	load_abs_long_index_x16
	docount 4, 5+1
	xor16
	dobreak
op5Fm0x1:
	load_abs_long_index_x8
	docount 4, 5+1
	xor16
	dobreak
op5Fm1x0:
	load_abs_long_index_x16
	docount 4, 5
	xor8
	dobreak
op5Fm1x1:
	load_abs_long_index_x8
	docount 4, 5
	xor8
	dobreak
op60m0x0: ;	"RTS", 1, 6,
op60m0x1:
op60m1x0:
op60m1x1:
	pullbyte dl
	pullbyte dh
	docount 1, 6
	dobreak
op61m0x0: ;	"ADC (<%b,X)", 2, 6,
	load_dir_index_indir_x16
	docount 2, 6+1
	adc16
	dobreak
op61m0x1:
	load_dir_index_indir_x8
	docount 2, 6+1
	adc16
	dobreak
op61m1x0:
	load_dir_index_indir_x16
	docount 2, 6
	adc8
	dobreak
op61m1x1:
	load_dir_index_indir_x8
	docount 2, 6
	adc8
	dobreak
op62m0x0: ;	"PSH @%w", 3, 6, // PER
op62m0x1:
op62m1x0:
op62m1x1:
	shr ebx, 8
	docount 3, 6
	add ebx, edx
	pushbyte bh
	pushbyte bl
	dobreak
op63m0x0: ;	"ADC <%b,s", 2, 4,
op63m0x1:
	load_s_rel
	docount 2, 4+1
	adc16
	dobreak
op63m1x0:
op63m1x1:
	load_s_rel
	docount 2, 4
	adc8
	dobreak
op64m0x0: ;	"CLR <%b", 2, 3,
op64m0x1:
	load_dir
	docount 2, 3+2
	clr16
	dobreak
op64m1x0:
op64m1x1:
	load_dir
	docount 2, 3
	clr8
	dobreak
op65m0x0: ;	"ADC <%b", 2, 3,
op65m0x1:
	load_dir
	docount 2, 3+1
	adc16
	dobreak
op65m1x0:
op65m1x1:
	load_dir
	docount 2, 3
	adc8
	dobreak
op66m0x0: ;	"ROR <%b", 2, 5,
op66m0x1:
	load_dir
	docount 2, 5+1
	ror16
	dobreak
op66m1x0:
op66m1x1:
	load_dir
	docount 2, 5
	ror8
	dobreak
op67m0x0: ;	"ADC [<%b]", 2, 6,
op67m0x1:
	load_dir_indir_long
	docount 2, 6+1
	adc16
	dobreak
op67m1x0:
op67m1x1:
	load_dir_indir_long
	docount 2, 6
	adc8
	dobreak
op68m0x0: ;	"PUL A", 1, 4, // PLA
op68m0x1:
	pullbyte bl
	pullbyte bh
	and cl, 0FFh-FZERO-FNEGATIVE
	inc edx
	and ebx, 0000FFFFh
	jnz @F
	or cl, FZERO
@@:	test bh, 80h
	jz @F
	or cl, FNEGATIVE
@@:	sub esi, 4+1
	mov dword [_reg.A], ebx
	dobreak
op68m1x0:
op68m1x1:
	pullbyte bl
	and cl, 0FFh-FZERO-FNEGATIVE
	inc edx
	test bl, bl
	jns @F
	or  cl, FNEGATIVE
@@:	jnz @F
	or  cl, FZERO
@@:	sub esi, 4
	mov byte [_reg.A], bl
	dobreak
op69m0x0: ;	"ADC %#", 2, 2,
op69m0x1:
	get_imm
	docount 2+1, 2+1
	adc16 imm
	dobreak
op69m1x0:
op69m1x1:
	get_imm
	docount 2, 2
	adc8 imm
	dobreak
op6Am0x0: ;	"ROR A", 1, 2,
op6Am0x1:
	docount 1, 2
	ror16_a
	dobreak
op6Am1x0:
op6Am1x1:
	docount 1, 2
	ror8_a
	dobreak
op6Bm0x0: ;	"RTL", 1, 6,
op6Bm0x1:
op6Bm1x0:
op6Bm1x1:
	xor edx, edx
	pullbyte dl
	pullbyte dh
	xor ebx, ebx
	pullbyte bl
	shl ebx, 16
	or  edx, ebx
	docount 1, 6
	dobreak
op6Cm0x0: ;	"JMP (%w)", 3, 5,
op6Cm0x1:
op6Cm1x0:
op6Cm1x1:
	shr ebx, 8
	and ebx, 0FFFFh
	convert_snesptr ebx ; value at memory location IN BANK 0 is where to jump to
	trapandread16 ebx
	sub esi, 5
	mov dx, bx
	dobreak
op6Dm0x0: ;	"ADC %w", 3, 4,
op6Dm0x1:
	load_abs
	docount 3, 4+1
	adc16
	dobreak
op6Dm1x0:
op6Dm1x1:
	load_abs
	docount 3, 4
	adc8
	dobreak
op6Em0x0: ;	"ROR %w", 3, 6,
op6Em0x1:
	load_abs
	docount 3, 6+1
	ror16
	dobreak
op6Em1x0:
op6Em1x1:
	load_abs
	docount 3, 6
	ror8
	dobreak
op6Fm0x0: ;	"ADC %L", 4, 5,
op6Fm0x1:
	load_abs_long
	docount 4, 5+1
	adc16
	dobreak
op6Fm1x0:
op6Fm1x1:
	load_abs_long
	docount 4, 5
	adc8
	dobreak
op70m0x0: ;	"BVS @%b", 2, 2,
op70m0x1:
op70m1x0:
op70m1x1:
	add edx, 2   ; PC += 2
	test cl, FOVERFLOW
	jnz @F       ; Branch
	sub esi, 2   ; cycle count
	dobreak
@@: shr ebx, 8
	sub esi, 3   ; cycle count
	movsx ebx, bl ; signed byte
	add dx, bx
	dobreak
op71m0x0: ;	"ADC (<%b),Y", 2, 5,
	load_dir_indir_index_y16
	docount 2, 5+1
	adc16
	dobreak
op71m0x1:
	load_dir_indir_index_y8
	docount 2, 5+1
	adc16
	dobreak
op71m1x0:
	load_dir_indir_index_y16
	docount 2, 5
	adc8
	dobreak
op71m1x1:
	load_dir_indir_index_y8
	docount 2, 5
	adc8
	dobreak
op72m0x0: ;	"ADC (<%b)", 2, 5,
op72m0x1:
	load_dir_indir
	docount 2, 5+1
	adc16
	dobreak
op72m1x0:
op72m1x1:
	load_dir_indir
	docount 2, 5
	adc8
	dobreak
op73m0x0: ;	"ADC (<%b,s),Y", 2, 7,
	load_s_rel_indir_index_y16
	docount 2, 7+1
	adc16
	dobreak
op73m0x1:
	load_s_rel_indir_index_y8
	docount 2, 7+1
	adc16
	dobreak
op73m1x0:
	load_s_rel_indir_index_y16
	docount 2, 7
	adc8
	dobreak
op73m1x1:
	load_s_rel_indir_index_y8
	docount 2, 7
	adc8
	dobreak
op74m0x0: ;	"CLR <%b,X", 2, 4,
	load_dir_index_x16
	docount 2, 4+1
	clr16
	dobreak
op74m0x1:
	load_dir_index_x8
	docount 2, 4+1
	clr16
	dobreak
op74m1x0:
	load_dir_index_x16
	docount 2, 4
	clr8
	dobreak
op74m1x1:
	load_dir_index_x8
	docount 2, 4
	clr8
	dobreak
op75m0x0: ;	"ADC <%b,X", 2, 4,
	load_dir_index_x16
	docount 2, 4+1
	adc16
	dobreak
op75m0x1:
	load_dir_index_x8
	docount 2, 4+1
	adc16
	dobreak
op75m1x0:
	load_dir_index_x16
	docount 2, 4
	adc8
	dobreak
op75m1x1:
	load_dir_index_x8
	docount 2, 4
	adc8
	dobreak
op76m0x0: ;	"ROR <%b,X", 2, 6,
	load_dir_index_x16
	docount 2, 6+1
	ror16
	dobreak
op76m0x1:
	load_dir_index_x8
	docount 2, 6+1
	ror16
	dobreak
op76m1x0:
	load_dir_index_x16
	docount 2, 6
	ror8
	dobreak
op76m1x1:
	load_dir_index_x8
	docount 2, 6
	ror8
	dobreak
op77m0x0: ;	"ADC [<%b],Y", 2, 6,
	load_dir_indir_long_index_y16
	docount 2, 6+1
	adc16
	dobreak
op77m0x1:
	load_dir_indir_long_index_y8
	docount 2, 6+1
	adc16
	dobreak
op77m1x0:
	load_dir_indir_long_index_y16
	docount 2, 6
	adc8
	dobreak
op77m1x1:
	load_dir_indir_long_index_y8
	docount 2, 6
	adc8
	dobreak
op78m0x0: ;	"SEI", 1, 2,
op78m0x1:
op78m1x0:
op78m1x1:
	or  cl, FINTERRUPT
	docount 1, 2
	dobreak;
op79m0x0: ;	"ADC %w,Y", 3, 4,
	load_abs_index_y16
	docount 3, 4+1
	adc16
	dobreak
op79m0x1:
	load_abs_index_y8
	docount 3, 4+1
	adc16
	dobreak
op79m1x0:
	load_abs_index_y16
	docount 3, 4
	adc8
	dobreak
op79m1x1:
	load_abs_index_y8
	docount 3, 4
	adc8
	dobreak
op7Am0x0: ;	"PUL Y", 1, 4, // PLY
op7Am1x0:
	pullbyte bl
	pullbyte bh
	and cl, 0FFh-FZERO-FNEGATIVE
	inc edx
	and ebx, 0000FFFFh
	jnz @F
	or cl, FZERO
@@:	test bh, 80h
	jz @F
	or cl, FNEGATIVE
@@:	sub esi, 4+1
	mov dword [_reg.Y], ebx
	dobreak
op7Am0x1:
op7Am1x1:
	pullbyte bl
	and cl, 0FFh-FZERO-FNEGATIVE
	inc edx
	test bl, bl
	jns @F
	or  cl, FNEGATIVE
@@:	jnz @F
	or  cl, FZERO
@@:	sub esi, 4
	mov byte [_reg.Y], bl
	dobreak
op7Bm0x0: ;	"TDA", 1, 2,
op7Bm0x1:
op7Bm1x0:
op7Bm1x1:
	and cl, 0FFh-FZERO-FNEGATIVE
	mov eax, dword [_reg.D]
	test eax, eax
	jnz @F
	or cl, FZERO
@@:	mov dword [_reg.A], eax
	test ah, 80h
	jns @F
	or  cl, FNEGATIVE
@@: docount 1, 2
	dobreak
op7Cm0x0: ;	"JMP (%w,X)", 3, 6,
op7Cm1x0:
	load_abs_index_indir_x16_code
	sub esi, 6
	mov edx, ebx
	dobreak
op7Cm0x1:
op7Cm1x1:
	load_abs_index_indir_x8_code
	sub esi, 6
	mov edx, ebx
	dobreak
op7Dm0x0: ;	"ADC %w,X", 3,4,
	load_abs_index_x16
	docount 3, 4+1
	adc16
	dobreak
op7Dm0x1:
	load_abs_index_x8
	docount 3, 4+1
	adc16
	dobreak
op7Dm1x0:
	load_abs_index_x16
	docount 3, 4
	adc8
	dobreak
op7Dm1x1:
	load_abs_index_x8
	docount 3, 4
	adc8
	dobreak
op7Em0x0: ;	"ROR %w,X", 3,7,
	load_abs_index_x16
	docount 3, 7+1
	ror16
	dobreak
op7Em0x1:
	load_abs_index_x8
	docount 3, 7+1
	ror16
	dobreak
op7Em1x0:
	load_abs_index_x16
	docount 3, 7
	ror8
	dobreak
op7Em1x1:
	load_abs_index_x8
	docount 3, 7
	ror8
	dobreak
op7Fm0x0: ;	"ADC %L,X",4,5,
	load_abs_long_index_x16
	docount 4, 5+1
	adc16
	dobreak
op7Fm0x1:
	load_abs_long_index_x8
	docount 4, 5+1
	adc16
	dobreak
op7Fm1x0:
	load_abs_long_index_x16
	docount 4, 5
	adc8
	dobreak
op7Fm1x1:
	load_abs_long_index_x8
	docount 4, 5
	adc8
	dobreak
op80m0x0: ;	"BRA @%b", 2, 2,
op80m0x1:
op80m1x0:
op80m1x1:
	add edx, 2   ; PC += 2
	movsx ebx, bh ; signed byte
	sub esi, 2   ; cycle count
	add dx, bx
	dobreak
op81m0x0: ;	"STA (<%b,X)", 2, 6,
	load_dir_index_indir_x16
	docount 2, 6+1
	sta16
	dobreak
op81m0x1:
	load_dir_index_indir_x8
	docount 2, 6+1
	sta16
	dobreak
op81m1x0:
	load_dir_index_indir_x16
	docount 2, 6
	sta8
	dobreak
op81m1x1:
	load_dir_index_indir_x8
	docount 2, 6
	sta8
	dobreak
op82m0x0: ;	"BRL @%w", 3, 3,
op82m0x1:
op82m1x0:
op82m1x1:
	add edx, 3   ; PC += 2
	shr ebx, 8   ; get signed word
	sub esi, 3   ; cycle count
	add dx, bx
	dobreak
op83m0x0: ;	"STA <%b,S", 2, 4,
op83m0x1:
	load_s_rel
	docount 2, 4+1
	sta16
	dobreak
op83m1x0:
op83m1x1:
	load_s_rel
	docount 2, 4
	sta8
	dobreak
op84m0x0: ;	"STY <%b", 2, 3,
op84m1x0:
	load_dir
	docount 2, 3+1
	sty16
	dobreak
op84m0x1:
op84m1x1:
	load_dir
	docount 2, 3
	sty8
	dobreak
op85m0x0: ;	"STA <%b", 2, 3,
op85m0x1:
	load_dir
	docount 2, 3+1
	sta16
	dobreak
op85m1x0:
op85m1x1:
	load_dir
	docount 2, 3
	sta8
	dobreak
op86m0x0: ;	"STX <%b", 2, 3,
op86m1x0:
	load_dir
	docount 2, 3+1
	stx16
	dobreak
op86m0x1:
op86m1x1:
	load_dir
	docount 2, 3
	stx8
	dobreak
op87m0x0: ;	"STA [<%b]", 2, 6,
op87m0x1:
	load_dir_indir_long
	docount 2, 6+1
	sta16
	dobreak
op87m1x0:
op87m1x1:
	load_dir_indir_long
	docount 2, 6
	sta8
	dobreak
op88m0x0: ;	"DEY", 1, 2,
op88m1x0:
	docount 1, 2
	dey16
	dobreak
op88m0x1:
op88m1x1:
	docount 1, 2
	dey8
	dobreak
op89m0x0: ;	"BIT %#", 2, 2,
op89m0x1:
	get_imm
	docount 2+1, 2+1
	bit16 imm
	dobreak
op89m1x0:
op89m1x1:
	get_imm
	docount 2, 2
	bit8 imm
	dobreak
op8Am0x0: ;	"TXA", 1, 2,
	transfer_16to16 X, A
	docount 1, 2
	dobreak
op8Am0x1:
	transfer_8to16 X, A
	docount 1, 2
	dobreak
op8Am1x0:
op8Am1x1:
	transfer_8to8 X, A
	docount 1, 2
	dobreak
op8Bm0x0: ;	"PSH DBR", 1, 3, // PHB
op8Bm0x1:
op8Bm1x0:
op8Bm1x1:
	inc edx
	mov bl, byte [_reg.DBR]
	sub esi, 3
	pushbyte bl
	dobreak
op8Cm0x0: ;	"STY %w", 3, 4,
op8Cm1x0:
	load_abs
	docount 3, 4+1
	sty16
	dobreak
op8Cm0x1:
op8Cm1x1:
	load_abs
	docount 3, 4
	sty8
	dobreak
op8Dm0x0: ;	"STA %w", 3, 4,
op8Dm0x1:
	load_abs
	docount 3, 4+1
	sta16
	dobreak
op8Dm1x0:
op8Dm1x1:
	load_abs
	docount 3, 4
	sta8
	dobreak
op8Em0x0: ;	"STX %w", 3, 4,
op8Em1x0:
	load_abs
	docount 3, 4+1
	stx16
	dobreak
op8Em0x1:
op8Em1x1:
	load_abs
	docount 3, 4
	stx8
	dobreak
op8Fm0x0: ;	"STA %L", 4, 5,
op8Fm0x1:
	load_abs_long
	docount 4, 5+1
	sta16
	dobreak
op8Fm1x0:
op8Fm1x1:
	load_abs_long
	docount 4, 5
	sta8
	dobreak
op90m0x0: ;	"BCC @%b", 2, 2,
op90m0x1:
op90m1x0:
op90m1x1:
	add edx, 2    ; PC += 2
	test cl, FCARRY
	jz @F         ; Branch
	sub esi, 2    ; cycle count
	dobreak
@@: movsx ebx, bh ; signed byte
	sub esi, 3    ; cycle count
	add dx, bx
	dobreak
op91m0x0: ;	"STA (<%b),Y", 2, 6,
	load_dir_indir_index_y16
	docount 2, 6+1
	sta16
	dobreak
op91m0x1:
	load_dir_indir_index_y8
	docount 2, 6+1
	sta16
	dobreak
op91m1x0:
	load_dir_indir_index_y16
	docount 2, 6
	sta8
	dobreak
op91m1x1:
	load_dir_indir_index_y8
	docount 2, 6
	sta8
	dobreak
op92m0x0: ;	"STA (<%b)", 2, 5,
op92m0x1:
	load_dir_indir
	docount 2, 5+1
	sta16
	dobreak
op92m1x0:
op92m1x1:
	load_dir_indir
	docount 2, 5
	sta8
	dobreak
op93m0x0: ;	"STA (<%b,s),Y", 2, 7,
	load_s_rel_indir_index_y16
	docount 2, 7+1
	sta16
	dobreak
op93m0x1:
	load_s_rel_indir_index_y8
	docount 2, 7+1
	sta16
	dobreak
op93m1x0:
	load_s_rel_indir_index_y16
	docount 2, 7
	sta8
	dobreak
op93m1x1:
	load_s_rel_indir_index_y8
	docount 2, 7
	sta8
	dobreak
op94m0x0: ;	"STY <%b,X", 2, 4,
op94m1x0:
	load_dir_index_x16
	docount 2, 4+1
	sty16
	dobreak
op94m0x1:
op94m1x1:
	load_dir_index_x8
	docount 2, 4
	sty8
	dobreak
op95m0x0: ;	"STA <%b,X", 2, 4,
	load_dir_index_x16
	docount 2, 4+1
	sta16
	dobreak
op95m0x1:
	load_dir_index_x8
	docount 2, 4+1
	sta16
	dobreak
op95m1x0:
	load_dir_index_x16
	docount 2, 4
	sta8
	dobreak
op95m1x1:
	load_dir_index_x8
	docount 2, 4
	sta8
	dobreak
op96m0x0: ;	"STX <%b,Y", 2, 4,
op96m1x0:
	load_dir_index_y16
	docount 2, 4+1
	stx16
	dobreak
op96m0x1:
op96m1x1:
	load_dir_index_y8
	docount 2, 4
	stx8
	dobreak
op97m0x0: ;	"STA [<%b],Y", 2, 6,
	load_dir_indir_long_index_y16
	docount 2, 6+1
	sta16
	dobreak
op97m0x1:
	load_dir_indir_long_index_y8
	docount 2, 6+1
	sta16
	dobreak
op97m1x0:
	load_dir_indir_long_index_y16
	docount 2, 6
	sta8
	dobreak
op97m1x1:
	load_dir_indir_long_index_y8
	docount 2, 6
	sta8
	dobreak
op98m0x0: ;	"TYA", 1, 2,
	transfer_16to16 Y, A
	docount 1, 2
	dobreak
op98m0x1:
	transfer_8to16 Y, A
	docount 1, 2
	dobreak
op98m1x0:
op98m1x1:
	transfer_8to8 Y, A
	docount 1, 2
	dobreak
op99m0x0: ;	"STA %w,Y", 3, 5,
	load_abs_index_y16
	docount 3, 5+1
	sta16
	dobreak
op99m0x1:
	load_abs_index_y8
	docount 3, 5+1
	sta16
	dobreak
op99m1x0:
	load_abs_index_y16
	docount 3, 5
	sta8
	dobreak
op99m1x1:
	load_abs_index_y8
	docount 3, 5
	sta8
	dobreak
op9Am0x0: ;	"TXS", 1, 2,
op9Am0x1:
op9Am1x0:
op9Am1x1:
	mov ebx, dword [_reg.X]
	docount 1, 2
	mov dword [_reg.S], ebx
	dobreak
op9Bm0x0: ;	"TXY", 1, 2,
op9Bm1x0:
	transfer_16to16 X, Y
	docount 1, 2
	dobreak
op9Bm0x1:
op9Bm1x1:
	transfer_8to8 X, Y
	docount 1, 2
	dobreak
op9Cm0x0: ;	"CLR %w", 3, 4,
op9Cm0x1:
	load_abs
	docount 3, 4+1
	clr16
	dobreak
op9Cm1x0:
op9Cm1x1:
	load_abs
	docount 3, 4
	clr8
	dobreak
op9Dm0x0: ;	"STA %w,X", 3, 5,
	load_abs_index_x16
	docount 3, 5+1
	sta16
	dobreak
op9Dm0x1:
	load_abs_index_x8
	docount 3, 5+1
	sta16
	dobreak
op9Dm1x0:
	load_abs_index_x16
	docount 3, 5
	sta8
	dobreak
op9Dm1x1:
	load_abs_index_x8
	docount 3, 5
	sta8
	dobreak
op9Em0x0: ;	"CLR %w,X", 3, 5,
	load_abs_index_x16
	docount 3, 5+1
	clr16
	dobreak
op9Em0x1:
	load_abs_index_x8
	docount 3, 5+1
	clr16
	dobreak
op9Em1x0:
	load_abs_index_x16
	docount 3, 5
	clr8
	dobreak
op9Em1x1:
	load_abs_index_x8
	docount 3, 5
	clr8
	dobreak
op9Fm0x0: ;	"STA %L,X", 4, 5,
	load_abs_long_index_x16
	docount 4, 5+1
	sta16
	dobreak
op9Fm0x1:
	load_abs_long_index_x8
	docount 4, 5+1
	sta16
	dobreak
op9Fm1x0:
	load_abs_long_index_x16
	docount 4, 5
	sta8
	dobreak
op9Fm1x1:
	load_abs_long_index_x8
	docount 4, 5
	sta8
	dobreak
opA0m0x0: ;	"LDY %#i", 2, 2,
opA0m1x0:
	get_imm
	docount 2+1, 2+1
	ldy16 imm
	dobreak
opA0m0x1:
opA0m1x1:
	get_imm
	docount 2, 2
	ldy8 imm
	dobreak
opA1m0x0: ;	"LDA (<%b,X)", 2, 6,
	load_dir_index_indir_x16
	docount 2, 6+1
	lda16
	dobreak
opA1m0x1:
	load_dir_index_indir_x8
	docount 2, 6+1
	lda16
	dobreak
opA1m1x0:
	load_dir_index_indir_x16
	docount 2, 6
	lda8
	dobreak
opA1m1x1:
	load_dir_index_indir_x8
	docount 2, 6
	lda8
	dobreak
opA2m0x0: ;	"LDX %#i", 2, 2,
opA2m1x0:
	get_imm
	docount 2+1, 2+1
	ldx16 imm
	dobreak
opA2m0x1:
opA2m1x1:
	get_imm
	docount 2, 2
	ldx8 imm
	dobreak
opA3m0x0: ;	"LDA <%b,S", 2, 4,
opA3m0x1:
	load_s_rel
	docount 2, 4+1
	lda16
	dobreak
opA3m1x0:
opA3m1x1:
	load_s_rel
	docount 2, 4
	lda8
	dobreak
opA4m0x0: ;	"LDY <%b", 2, 3,
opA4m1x0:
	load_dir
	docount 2, 3+1
	ldy16
	dobreak
opA4m0x1:
opA4m1x1:
	load_dir
	docount 2, 3
	ldy8
	dobreak
opA5m0x0: ;	"LDA <%b", 2, 3,
opA5m0x1:
	load_dir
	docount 2, 3+1
	lda16
	dobreak
opA5m1x0:
opA5m1x1:
	load_dir
	docount 2, 3
	lda8
	dobreak
opA6m0x0: ;	"LDX <%b", 2, 3,
opA6m1x0:
	load_dir
	docount 2, 3+1
	ldx16
	dobreak
opA6m0x1:
opA6m1x1:
	load_dir
	docount 2, 3
	ldx8
	dobreak
opA7m0x0: ;	"LDA [<%b]", 2, 6,
opA7m0x1:
	load_dir_indir_long
	docount 2, 6+1
	lda16
	dobreak
opA7m1x0:
opA7m1x1:
	load_dir_indir_long
	docount 2, 6
	lda8
	dobreak
opA8m0x0: ;	"TAY", 1, 2,
	transfer_16to16 A, Y
	docount 1, 2
	dobreak
opA8m1x0:
	transfer_8to16 A, Y
	docount 1, 2
	dobreak
opA8m0x1:
opA8m1x1:
	transfer_8to8 A, Y
	docount 1, 2
	dobreak
opA9m0x0: ;	"LDA %#", 2, 2,
opA9m0x1:
	get_imm
	docount 2+1, 2+1
	lda16 imm
	dobreak
opA9m1x0:
opA9m1x1:
	get_imm
	docount 2, 2
	lda8 imm
	dobreak
opAAm0x0: ;	"TAX", 1, 2,
	transfer_16to16 A, X
	docount 1, 2
	dobreak
opAAm1x0:
	transfer_8to16 A, X
	docount 1, 2
	dobreak
opAAm0x1:
opAAm1x1:
	transfer_8to8 A, X
	docount 1, 2
	dobreak
opABm0x0: ;	"PUL DBR", 1, 4, // PLB
opABm0x1:
opABm1x0:
opABm1x1:
	pullbyte bl
	docount 1, 4
	mov byte [_reg.DBR], bl
	and cl, 0FFh-FZERO-FNEGATIVE
	test bl, bl
	jnz @F
	or cl, FZERO
@@:	jns @F
	or cl, FNEGATIVE
@@:	dobreak
opACm0x0: ;	"LDY %w", 3, 4,
opACm1x0:
	load_abs
	docount 3, 4+1
	ldy16
	dobreak
opACm0x1:
opACm1x1:
	load_abs
	docount 3, 4
	ldy8
	dobreak
opADm0x0: ;	"LDA %w", 3, 4,
opADm0x1:
	load_abs
	docount 3, 4+1
	lda16
	dobreak
opADm1x0:
opADm1x1:
	load_abs
	docount 3, 4
	lda8
	dobreak
opAEm0x0: ;	"LDX %w", 3, 4,
opAEm1x0:
	load_abs
	docount 3, 4+1
	ldx16
	dobreak
opAEm0x1:
opAEm1x1:
	load_abs
	docount 3, 4
	ldx8
	dobreak
opAFm0x0: ;	"LDA %L", 4, 5,
opAFm0x1:
	load_abs_long
	docount 4, 5+1
	lda16
	dobreak
opAFm1x0:
opAFm1x1:
	load_abs_long
	docount 4, 5
	lda8
	dobreak
opB0m0x0: ;	"BCS @%b", 2, 2,
opB0m0x1:
opB0m1x0:
opB0m1x1:
	add edx, 2   ; PC += 2
	test cl, FCARRY
	jnz @F       ; Branch
	sub esi, 2   ; cycle count
	dobreak
@@: shr ebx, 8
	sub esi, 3   ; cycle count
	movsx ebx, bl ; signed byte
	add dx, bx
	dobreak
opB1m0x0: ;	"LDA (<%b),Y", 2, 5,
	load_dir_indir_index_y16
	docount 2, 5+1
	lda16
	dobreak
opB1m0x1:
	load_dir_indir_index_y8
	docount 2, 5+1
	lda16
	dobreak
opB1m1x0:
	load_dir_indir_index_y16
	docount 2, 5
	lda8
	dobreak
opB1m1x1:
	load_dir_indir_index_y8
	docount 2, 5
	lda8
	dobreak
opB2m0x0: ;	"LDA (<%b)", 2, 5,
opB2m0x1:
	load_dir_indir
	docount 2, 5+1
	lda16
	dobreak
opB2m1x0:
opB2m1x1:
	load_dir_indir
	docount 2, 5
	lda8
	dobreak
opB3m0x0: ;	"LDA (<%b,S),Y", 2, 7,
	load_s_rel_indir_index_y16
	docount 2, 7+1
	lda16
	dobreak
opB3m0x1:
	load_s_rel_indir_index_y8
	docount 2, 7+1
	lda16
	dobreak
opB3m1x0:
	load_s_rel_indir_index_y16
	docount 2, 7
	lda8
	dobreak
opB3m1x1:
	load_s_rel_indir_index_y8
	docount 2, 7
	lda8
	dobreak
opB4m0x0: ;	"LDY <%b,X", 2, 4,
opB4m1x0:
	load_dir_index_x16
	docount 2, 4+1
	ldy16
	dobreak
opB4m0x1:
opB4m1x1:
	load_dir_index_x8
	docount 2, 4
	ldy8
	dobreak
opB5m0x0: ;	"LDA <%b,X", 2, 4,
	load_dir_index_x16
	docount 2, 4+1
	lda16
	dobreak
opB5m0x1:
	load_dir_index_x8
	docount 2, 4+1
	lda16
	dobreak
opB5m1x0:
	load_dir_index_x16
	docount 2, 4
	lda8
	dobreak
opB5m1x1:
	load_dir_index_x8
	docount 2, 4
	lda8
	dobreak
opB6m0x0: ;	"LDX <%b,Y", 2, 4,
opB6m1x0:
	load_dir_index_y16
	docount 2, 4+1
	ldx16
	dobreak
opB6m0x1:
opB6m1x1:
	load_dir_index_y8
	docount 2, 4
	ldx8
	dobreak
opB7m0x0: ;	"LDA [<%b],Y", 2, 6,
	load_dir_indir_long_index_y16
	docount 2, 6+1
	lda16
	dobreak
opB7m0x1:
	load_dir_indir_long_index_y8
	docount 2, 6+1
	lda16
	dobreak
opB7m1x0:
	load_dir_indir_long_index_y16
	docount 2, 6
	lda8
	dobreak
opB7m1x1:
	load_dir_indir_long_index_y8
	docount 2, 6
	lda8
	dobreak
opB8m0x0: ;	"CLV", 1, 2,
opB8m0x1:
opB8m1x0:
opB8m1x1:
	docount 1, 2
	and cl, 0FFh-FOVERFLOW
	dobreak
opB9m0x0: ;	"LDA %w,Y", 3, 4,
	load_abs_index_y16
	docount 3, 4+1
	lda16
	dobreak
opB9m0x1:
	load_abs_index_y8
	docount 3, 4+1
	lda16
	dobreak
opB9m1x0:
	load_abs_index_y16
	docount 3, 4
	lda8
	dobreak
opB9m1x1:
	load_abs_index_y8
	docount 3, 4
	lda8
	dobreak
opBAm0x0: ;	"TSX", 1, 2,
opBAm1x0:
	transfer_16to16 S, X
	docount 1, 2
	dobreak
opBAm0x1:
opBAm1x1:
	transfer_8to8 S, X
	docount 1, 2
	dobreak
opBBm0x0: ;	"TYX", 1, 2,
opBBm1x0:
	transfer_16to16 Y, X
	docount 1, 2
	dobreak
opBBm0x1:
opBBm1x1:
	transfer_8to8 Y, X
	docount 1, 2
	dobreak
opBCm0x0: ;	"LDY %w,X", 3, 4,
opBCm1x0:
	load_abs_index_x16
	docount 3, 4+1
	ldy16
	dobreak
opBCm0x1:
opBCm1x1:
	load_abs_index_x8
	docount 3, 4
	ldy8
	dobreak
opBDm0x0: ;	"LDA %w,X", 3, 4,
	load_abs_index_x16
	docount 3, 4+1
	lda16
	dobreak
opBDm0x1:
	load_abs_index_x8
	docount 3, 4+1
	lda16
	dobreak
opBDm1x0:
	load_abs_index_x16
	docount 3, 4
	lda8
	dobreak
opBDm1x1:
	load_abs_index_x8
	docount 3, 4
	lda8
	dobreak
opBEm0x0: ;	"LDX %w,Y", 3, 4,
opBEm1x0:
	load_abs_index_y16
	docount 3, 4+1
	ldx16
	dobreak
opBEm0x1:
opBEm1x1:
	load_abs_index_y8
	docount 3, 4
	ldx8
	dobreak
opBFm0x0: ;	"LDA %L,X",4, 5,
	load_abs_long_index_x16
	docount 4, 5+1
	lda16
	dobreak
opBFm0x1:
	load_abs_long_index_x8
	docount 4, 5+1
	lda16
	dobreak
oPBFm1x0:
	load_abs_long_index_x16
	docount 4, 5
	lda8
	dobreak
opBFm1x1:
	load_abs_long_index_x8
	docount 4, 5
	lda8
	dobreak
opC0m0x0: ;	"CPY %#i", 2, 2,
opC0m1x0:
	get_imm
	docount 2+1, 2+1
	cpy16 imm
	dobreak
opC0m0x1:
opC0m1x1:
	get_imm
	docount 2, 2
	cpy8 imm
	dobreak
opC1m0x0: ;	"CMP (<%b,X)", 2, 6,
	load_dir_index_indir_x16
	docount 2, 6+1
	cmp16
	dobreak
opC1m0x1:
	load_dir_index_indir_x8
	docount 2, 6+1
	cmp16
	dobreak
opC1m1x0:
	load_dir_index_indir_x16
	docount 2, 6
	cmp8
	dobreak
opC1m1x1:
	load_dir_index_indir_x8
	docount 2, 6
	cmp8
	dobreak
opC2m0x0: ;	"CLP %#b", 2, 3,
opC2m0x1:
opC2m1x0:
opC2m1x1:
	not bh
	docount 2, 3
	and cl, bh
	or  byte [_reg.E], 0
	jz  @F
	or  cl, 30h ; MX must be 1 all the time...
@@:	dobreak_mxchange
opC3m0x0: ;	"CMP <%b,S", 2, 4,
opC3m0x1:
	load_s_rel
	docount 2, 4+1
	cmp16
	dobreak
opC3m1x0:
opC3m1x1:
	load_s_rel
	docount 2, 4
	cmp8
	dobreak
opC4m0x0: ;	"CPY <%b", 2, 3,
opC4m1x0:
	load_dir
	docount 2, 3+1
	cpy16
	dobreak
opC4m0x1:
opC4m1x1:
	load_dir
	docount 2, 3
	cpy8
	dobreak
opC5m0x0: ;	"CMP <%b", 2, 3,
opC5m0x1:
	load_dir
	docount 2, 3+1
	cmp16
	dobreak
opC5m1x0:
opC5m1x1:
	load_dir
	docount 2, 3
	cmp8
	dobreak
opC6m0x0: ;	"DEC <%b", 2, 5,
opC6m0x1:
	load_dir
	docount 2, 5+1
	dec16
	dobreak
opC6m1x0:
opC6m1x1:
	load_dir
	docount 2, 5
	dec8
	dobreak
opC7m0x0: ;	"CMP [<%b]", 2,6,
opC7m0x1:
	load_dir_indir_long
	docount 2, 6+1
	cmp16
	dobreak
opC7m1x0:
opC7m1x1:
	load_dir_indir_long
	docount 2, 6
	cmp8
	dobreak
opC8m0x0: ;	"INY", 1, 2,
opC8m1x0:
	docount 1, 2
	iny16
	dobreak
opC8m0x1:
opC8m1x1:
	docount 1, 2
	iny8
	dobreak
opC9m0x0: ;	"CMP %#", 2, 2,
opC9m0x1:
	get_imm
	docount 2+1, 2+1
	cmp16 imm
	dobreak
opC9m1x0:
opC9m1x1:
	get_imm
	docount 2, 2
	cmp8 imm
	dobreak
opCAm0x0: ;	"DEX", 1, 2,
opCAm1x0:
	docount 1, 2
	dex16
	dobreak
opCAm0x1:
opCAm1x1:
	docount 1, 2
	dex8
	dobreak
opCBm0x0: ;	"WAI", 1, 3,
opCBm0x1:
opCBm1x0:
opCBm1x1: ; _state:endwai, _state+1:withinwai
	mov al, byte [_state]
	sub esi, 3
	test al, al
	jz within_wai
	mov al, byte [_state+1]
	test al, al
	jz within_wai
	inc edx               ; don't wait anymore
	mov byte [_state], 0
	mov byte [_state+1], 0
	dobreak
	within_wai:
	mov byte [_state], 0
	mov byte [_state+1], 1
	dobreak
opCCm0x0: ;	"CPY %w", 3, 4,
opCCm1x0:
	load_abs
	docount 3, 4+1
	cpy16
	dobreak
opCCm0x1:
opCCm1x1:
	load_abs
	docount 3, 4
	cpy8
	dobreak
opCDm0x0: ;	"CMP %w", 3, 4,
opCDm0x1:
	load_abs
	docount 3, 4+1
	cmp16
	dobreak
opCDm1x0:
opCDm1x1:
	load_abs
	docount 3, 4
	cmp8
	dobreak
opCEm0x0: ;	"DEC %w", 3, 6,
opCEm0x1:
	load_abs
	docount 3, 6+1
	dec16
	dobreak
opCEm1x0:
opCEm1x1:
	load_abs
	docount 3, 6
	dec8
	dobreak
opCFm0x0: ;	"CMP %L", 4, 5,
opCFm0x1:
	load_abs_long
	docount 4, 5+1
	cmp16
	dobreak
opCFm1x0:
opCFm1x1:
	load_abs_long
	docount 4, 5
	cmp8
	dobreak
opD0m0x0: ;	"BNE @%b", 2, 2,
opD0m0x1:
opD0m1x0:
opD0m1x1:
	add edx, 2    ; PC += 2
	test cl, FZERO
	jz @F         ; Branch
	sub esi, 2    ; cycle count
	dobreak
@@: movsx ebx, bh ; signed byte
	sub esi, 3    ; cycle count
	add dx, bx
	dobreak
opD1m0x0: ;	"CMP (<%b),Y", 2, 5,
	load_dir_indir_index_y16
	docount 2, 5+1
	cmp16
	dobreak
opD1m0x1:
	load_dir_indir_index_y8
	docount 2, 5+1
	cmp16
	dobreak
opD1m1x0:
	load_dir_indir_index_y16
	docount 2, 5
	cmp8
	dobreak
opD1m1x1:
	load_dir_indir_index_y8
	docount 2, 5
	cmp8
	dobreak
opD2m0x0: ;	"CMP (<%b)", 2, 5,
opD2m0x1:
	load_dir_indir
	docount 2, 5+1
	cmp16
	dobreak
opD2m1x0:
opD2m1x1:
	load_dir_indir
	docount 2, 5
	cmp8
	dobreak
opD3m0x0: ;	"CMP (<%b,S),Y", 2, 7,
	load_s_rel_indir_index_y16
	docount 2, 7+1
	cmp16
	dobreak
opD3m0x1:
	load_s_rel_indir_index_y8
	docount 2, 7+1
	cmp16
	dobreak
opD3m1x0:
	load_s_rel_indir_index_y16
	docount 2, 7
	cmp8
	dobreak
opD3m1x1:
	load_s_rel_indir_index_y8
	docount 2, 7
	cmp8
	dobreak
opD4m0x0: ; "PSH %b", 2, 6, // PEI
opD4m0x1:
opD4m1x0:
opD4m1x1:
	load_dir
	docount 2, 6
	trapandread16 ebx
	pushbyte bh
	pushbyte bl
	dobreak
opD5m0x0: ;	"CMP <%b,X", 2, 4,
	load_dir_index_x16
	docount 2, 4+1
	cmp16
	dobreak
opD5m0x1:
	load_dir_index_x8
	docount 2, 4+1
	cmp16
	dobreak
opD5m1x0:
	load_dir_index_x16
	docount 2, 4
	cmp8
	dobreak
opD5m1x1:
	load_dir_index_x8
	docount 2, 4
	cmp8
	dobreak
opD6m0x0: ;	"DEC <%b,X", 2, 6,
	load_dir_index_x16
	docount 2, 6+1
	dec16
	dobreak
opD6m0x1:
	load_dir_index_x8
	docount 2, 6+1
	dec16
	dobreak
opD6m1x0:
	load_dir_index_x16
	docount 2, 6
	dec8
	dobreak
opD6m1x1:
	load_dir_index_x8
	docount 2, 6
	dec8
	dobreak
opD7m0x0: ;	"CMP [<%b],Y", 2, 6,
	load_dir_indir_long_index_y16
	docount 2, 6+1
	cmp16
	dobreak
opD7m0x1:
	load_dir_indir_long_index_y8
	docount 2, 6+1
	cmp16
	dobreak
opD7m1x0:
	load_dir_indir_long_index_y16
	docount 2, 6
	cmp8
	dobreak
opD7m1x1:
	load_dir_indir_long_index_y8
	docount 2, 6
	cmp8
	dobreak
opD8m0x0: ;	"CLD", 1, 2,
opD8m0x1:
opD8m1x0:
opD8m1x1:
	docount 1, 2
	and cl, 0FFh-FDECIMAL
	dobreak
opD9m0x0: ;	"CMP %w,Y", 3, 4,
	load_abs_index_y16
	docount 3, 4+1
	cmp16
	dobreak
opD9m0x1:
	load_abs_index_y8
	docount 3, 4+1
	cmp16
	dobreak
opD9m1x0:
	load_abs_index_y16
	docount 3, 4
	cmp8
	dobreak
opD9m1x1:
	load_abs_index_y8
	docount 3, 4
	cmp8
	dobreak
opDAm0x0: ;	"PSH X", 1, 3, // PHX
opDAm1x0:
	mov ebx, dword [_reg.X]
	pushbyte bh
	docount 1, 3+1
	pushbyte bl
	dobreak
opDAm0x1:
opDAm1x1:
	mov bl, byte [_reg.X]
	docount 1, 3
	pushbyte bl
	dobreak
opDBm0x0: ;	"HLT", 1, 3, // STP
opDBm0x1:
opDBm1x0:
opDBm1x1:
	mov esi, -1
	mov [_returntogui], 1
	dobreak
opDCm0x0: ;	"JML (%w)", 3, 6,
opDCm0x1:
opDCm1x0:
opDCm1x1:
	load_abs_indir
	trapandread16 ebx
	sub esi, 6
	and ebx, 00FFFFFFh
	mov edx, ebx
	dobreak
opDDm0x0: ;	"CMP %w,X", 3, 4,
	load_abs_index_x16
	docount 3, 4+1
	cmp16
	dobreak
opDDm0x1:
	load_abs_index_x8
	docount 3, 4+1
	cmp16
	dobreak
opDDm1x0:
	load_abs_index_x16
	docount 3, 4
	cmp8
	dobreak
opDDm1x1:
	load_abs_index_x8
	docount 3, 4
	cmp8
	dobreak
opDEm0x0: ;	"DEC %w,X", 3, 7,
	load_abs_index_x16
	docount 3, 7+1
	dec16
	dobreak
opDEm0x1:
	load_abs_index_x8
	docount 3, 7+1
	dec16
	dobreak
opDEm1x0:
	load_abs_index_x16
	docount 3, 7
	dec8
	dobreak
opDEm1x1:
	load_abs_index_x8
	docount 3, 7
	dec8
	dobreak
opDFm0x0: ;	"CMP %L,X", 4, 5,
	load_abs_long_index_x16
	docount 4, 5+1
	cmp16
	dobreak
opDFm0x1:
	load_abs_long_index_x8
	docount 4, 5+1
	cmp16
	dobreak
opDFm1x0:
	load_abs_long_index_x16
	docount 4, 5
	cmp8
	dobreak
opDFm1x1:
	load_abs_long_index_x8
	docount 4, 5
	cmp8
	dobreak
opE0m0x0: ;	"CPX %#i", 2, 2,
opE0m1x0:
	get_imm
	docount 2+1, 2+1
	cpx16 imm
	dobreak
opE0m0x1:
opE0m1x1:
	get_imm
	docount 2, 2
	cpx8 imm
	dobreak
opE1m0x0: ;	"SBC (<%b,X)", 2, 6,
	load_dir_index_indir_x16
	docount 2, 6+1
	sbc16
	dobreak
opE1m0x1:
	load_dir_index_indir_x8
	docount 2, 6+1
	sbc16
	dobreak
opE1m1x0:
	load_dir_index_indir_x16
	docount 2, 6
	sbc8
	dobreak
opE1m1x1:
	load_dir_index_indir_x8
	docount 2, 6
	sbc8
	dobreak
opE2m0x0: ;	"SEP %#b", 2, 3,
opE2m0x1:
opE2m1x0:
opE2m1x1:
	or  cl, bh
	docount 2, 3
	test cl, 10h  ; 8-bit index?
	jz @F
	and dword [_reg.X], 0FFh ; clear high bytes
	and dword [_reg.Y], 0FFh
@@:	dobreak_mxchange
opE3m0x0: ;	"SBC <%b,s", 2, 4,
opE3m0x1:
	load_s_rel
	docount 2, 4+1
	sbc16
	dobreak
opE3m1x0:
opE3m1x1:
	load_s_rel
	docount 2, 4
	sbc8
	dobreak
opE4m0x0: ;	"CPX <%b", 2, 3,
opE4m1x0:
	load_dir
	docount 2, 3+1
	cpx16
	dobreak
opE4m0x1:
opE4m1x1:
	load_dir
	docount 2, 3
	cpx8
	dobreak
opE5m0x0: ;	"SBC <%b", 2, 3,
opE5m0x1:
	load_dir
	docount 2, 3+1
	sbc16
	dobreak
opE5m1x0:
opE5m1x1:
	load_dir
	docount 2, 3
	sbc8
	dobreak
opE6m0x0: ;	"INC <%b", 2, 5,
opE6m0x1:
	load_dir
	docount 2, 5+1
	inc16
	dobreak
opE6m1x0:
opE6m1x1:
	load_dir
	docount 2, 5
	inc8
	dobreak
opE7m0x0: ;	"SBC [<%b]", 2, 6,
opE7m0x1:
	load_dir_indir_long
	docount 2, 6+1
	sbc16
	dobreak
opE7m1x0:
opE7m1x1:
	load_dir_indir_long
	docount 2, 6
	sbc8
	dobreak
opE8m0x0: ;	"INX", 1, 2,
opE8m1x0:
	docount 1, 2
	inx16
	dobreak
opE8m0x1:
opE8m1x1:
	docount 1, 2
	inx8
	dobreak
opE9m0x0: ;	"SBC %#", 2, 2,
opE9m0x1:
	get_imm
	docount 2+1, 2+1
	sbc16 imm
	dobreak
opE9m1x0:
opE9m1x1:
	get_imm
	docount 2, 2
	sbc8 imm
	dobreak
opEAm0x0: ;	"NOP", 1, 2,
opEAm0x1:
opEAm1x0:
opEAm1x1:
	inc edx
	sub esi, 2
	dobreak
opEBm0x0: ;	"SWA", 1, 3,
opEBm0x1:
	mov eax, dword [_reg.A]
	docount 1, 3
	mov byte [_reg.A], ah
	and cl, 0FFh-FZERO-FNEGATIVE
	test al, 80h
	jz @F
	or  cl, FNEGATIVE
@@:	mov byte [_reg.A+1], al
	test eax, eax
	jnz @F
	or cl, FZERO
@@:	dobreak
opEBm1x0:
opEBm1x1:
	mov eax, dword [_reg.A]
	docount 1, 3
	mov byte [_reg.A], ah
	and ecx, 000000FFh-FZERO-FNEGATIVE
	test ah, ah
	jns @F
	mov ch, FNEGATIVE
@@:	mov byte [_reg.A+1], al
	jnz @F
	or cl, FZERO
@@:	or cl, ch
	dobreak
opECm0x0: ;	"CPX %w", 3, 4,
opECm1x0:
	load_abs
	docount 3, 4+1
	cpx16
	dobreak
opECm0x1:
opECm1x1:
	load_abs
	docount 3, 4
	cpx8
	dobreak
opEDm0x0: ;	"SBC %w", 3, 4,
opEDm0x1:
	load_abs
	docount 3, 4+1
	sbc16
	dobreak
opEDm1x0:
opEDm1x1:
	load_abs
	docount 3, 4
	sbc8
	dobreak
opEEm0x0: ;	"INC %w", 3, 6,
opEEm0x1:
	load_abs
	docount 3, 6+1
	inc16
	dobreak
opEEm1x0:
opEEm1x1:
	load_abs
	docount 3, 6
	inc8
	dobreak
opEFm0x0: ;	"SBC %L", 4, 5,
opEFm0x1:
	load_abs_long
	docount 4, 5+1
	sbc16
	dobreak
opEFm1x0:
opEFm1x1:
	load_abs_long
	docount 4, 5
	sbc8
	dobreak
opF0m0x0: ;	"BEQ @%b", 2, 2,
opF0m0x1:
opF0m1x0:
opF0m1x1:
	add edx, 2   ; PC += 2
	test cl, FZERO
	jnz @F       ; Branch
	sub esi, 2   ; cycle count
	dobreak
@@: shr ebx, 8
	sub esi, 3   ; cycle count
	movsx ebx, bl ; signed byte
	add dx, bx
	dobreak
opF1m0x0: ;	"SBC (<%b),Y", 2, 5,
	load_dir_indir_index_y16
	docount 2, 5+1
	sbc16
	dobreak
opF1m0x1:
	load_dir_indir_index_y8
	docount 2, 5+1
	sbc16
	dobreak
opF1m1x0:
	load_dir_indir_index_y16
	docount 2, 5
	sbc8
	dobreak
opF1m1x1:
	load_dir_indir_index_y8
	docount 2, 5
	sbc8
	dobreak
opF2m0x0: ;	"SBC (<%b)", 2, 5,
opF2m0x1:
	load_dir_indir
	docount 2, 5+1
	sbc16
	dobreak
opF2m1x0:
opF2m1x1:
	load_dir_indir
	docount 2, 5
	sbc8
	dobreak
opF3m0x0: ;	"SBC (<%b,S),Y", 2, 7,
	load_s_rel_indir_index_y16
	docount 2, 7+1
	sbc16
	dobreak
opF3m0x1:
	load_s_rel_indir_index_y8
	docount 2, 7+1
	sbc16
	dobreak
opF3m1x0:
	load_s_rel_indir_index_y16
	docount 2, 7
	sbc8
	dobreak
opF3m1x1:
	load_s_rel_indir_index_y8
	docount 2, 7
	sbc8
	dobreak
opF4m0x0: ;	"PSH %#w", 3, 5, // PEA
opF4m0x1:
opF4m1x0:
opF4m1x1:
	shr ebx, 8
	docount 3, 5
	pushbyte bh
	pushbyte bl
	dobreak
opF5m0x0: ;	"SBC <%b,X", 2, 4,
	load_dir_index_x16
	docount 2, 4+1
	sbc16
	dobreak
opF5m0x1:
	load_dir_index_x8
	docount 2, 4+1
	sbc16
	dobreak
opF5m1x0:
	load_dir_index_x16
	docount 2, 4
	sbc8
	dobreak
opF5m1x1:
	load_dir_index_x8
	docount 2, 4
	sbc8
	dobreak
opF6m0x0: ;	"INC <%b,X", 2, 6,
	load_dir_index_x16
	docount 2, 6+1
	inc16
	dobreak
opF6m0x1:
	load_dir_index_x8
	docount 2, 6+1
	inc16
	dobreak
opF6m1x0:
	load_dir_index_x16
	docount 2, 6
	inc8
	dobreak
opF6m1x1:
	load_dir_index_x8
	docount 2, 6
	inc8
	dobreak
opF7m0x0: ;	"SBC [<%b],Y", 2, 6,
	load_dir_indir_long_index_y16
	docount 2, 6+1
	sbc16
	dobreak
opF7m0x1:
	load_dir_indir_long_index_y8
	docount 2, 6+1
	sbc16
	dobreak
opF7m1x0:
	load_dir_indir_long_index_y16
	docount 2, 6
	sbc8
	dobreak
opF7m1x1:
	load_dir_indir_long_index_y8
	docount 2, 6
	sbc8
	dobreak
opF8m0x0: ;	"SED", 1, 2,
opF8m0x1:
opF8m1x0:
opF8m1x1:
	or  cl, FDECIMAL
	docount 1, 2
	dobreak;
opF9m0x0: ;	"SBC %w,Y", 3, 4,
	load_abs_index_y16
	docount 3, 4+1
	sbc16
	dobreak
opF9m0x1:
	load_abs_index_y8
	docount 3, 4+1
	sbc16
	dobreak
opF9m1x0:
	load_abs_index_y16
	docount 3, 4
	sbc8
	dobreak
opF9m1x1:
	load_abs_index_y8
	docount 3, 4
	sbc8
	dobreak
opFAm0x0: ;	"PUL X", 1, 4, // PLX
opFAm1x0:
	pullbyte bl
	pullbyte bh
	and cl, 0FFh-FZERO-FNEGATIVE
	inc edx
	and ebx, 0000FFFFh
	jnz @F
	or cl, FZERO
@@:	test bh, 80h
	jz @F
	or cl, FNEGATIVE
@@:	sub esi, 4+1
	mov dword [_reg.X], ebx
	dobreak
opFAm0x1:
opFAm1x1:
	pullbyte bl
	and cl, 0FFh-FZERO-FNEGATIVE
	inc edx
	test bl, bl
	jns @F
	or  cl, FNEGATIVE
@@:	jnz @F
	or  cl, FZERO
@@:	sub esi, 4
	mov byte [_reg.X], bl
	dobreak
opFBm0x0: ;	"XCE", 1, 2,
opFBm0x1:
opFBm1x0:
opFBm1x1:
	docount 1, 2
	mov ch, cl
	and cl, 0FFh-FCARRY
	or byte [_reg.E], 0
	jz @F
	or cl, FCARRY
@@: and ch, 1
	mov byte [_reg.E], ch
	jz nativemode ; native mode
	or cl, FINDEX+FMEMORY
	mov byte [_reg.S+1], 1
	and dword [_reg.X], 000000FFh
	and dword [_reg.Y], 000000FFh
	mov dword [_reg.D], 0
	test cl, 10h  ; 8-bit index?
	jz @F
	and dword [_reg.X], 0FFh ; clear high bytes
	and dword [_reg.Y], 0FFh
@@:	dobreak_mxchange
nativemode:
	dobreak
opFCm0x0: ;	"JSR (%w,X)", 3, 6,
opFCm1x0:
	docount 2, 6  ; save 1 less on stack
	load_abs_index_indir_x16_code
	;trapandread16 ebx  already read
	shortcall bl, bh
	dobreak
opFCm0x1:
opFCm1x1:
	docount 2, 6  ; save 1 less on stack
	load_abs_index_indir_x8_code
	; trapandread8 ebx already read
	shortcall bl, bh
	dobreak
opFDm0x0: ;	"SBC %w,X", 3, 4,
	load_abs_index_x16
	docount 3, 4+1
	sbc16
	dobreak
opFDm0x1:
	load_abs_index_x8
	docount 3, 4+1
	sbc16
	dobreak
opFDm1x0:
	load_abs_index_x16
	docount 3, 4
	sbc8
	dobreak
opFDm1x1:
	load_abs_index_x8
	docount 3, 4
	sbc8
	dobreak
opFEm0x0: ;	"INC %w,X", 3, 7,
	load_abs_index_x16
	docount 3, 7+1
	inc16
	dobreak
opFEm0x1:
	load_abs_index_x8
	docount 3, 7+1
	inc16
	dobreak
opFEm1x0:
	load_abs_index_x16
	docount 3, 7
	inc8
	dobreak
opFEm1x1:
	load_abs_index_x8
	docount 3, 7
	inc8
	dobreak
opFFm0x0: ;	"SBC %L,X", 4, 5
	load_abs_long_index_x16
	docount 4, 5+1
	sbc16
	dobreak
opFFm0x1:
	load_abs_long_index_x8
	docount 4, 5+1
	sbc16
	dobreak
opFFm1x0:
	load_abs_long_index_x16
	docount 4, 5
	sbc8
	dobreak
opFFm1x1:
	load_abs_long_index_x8
	docount 4, 5
	sbc8
	dobreak

_doemulate endp

;_TEXT ENDS

END

